/*
* BDCbrt.java -- {̗
* @version $Revision: 1.10 $, $Date: 2003/05/12 10:24:55 $
* BDTools.java gĂB
*/

import java.io.*;
import java.math.*;

/**
*{x̗܂͂̋t߂܂B
*/
public class BDCbrt {
    public static int itr;  // 񐔂ێĂB
    public static final int ITR_MAX = 20;  // 15 * 2^20 ܂ŁB
    public static final int DOUBLE_PREC =15; // double ̗L
    /**
    *̋t<code>1/<i>x</i><sup>1/3</sup></code>߂܂B
    *@param x <code>BigDecimal <i>x</i></code> ^܂B
    *@param precision x^܂B
    *@return <code>1/<i>x</i><sup>1/3</sup></code>Ԃ܂B
    *̂܂10iŏo͂Ƒ傫ȌɂȂ܂B̏ꍇ {@link BDTools#roundOff}
    *gĂBL2iŌςĂ邽߂łB
    * @see BDTools
    */
    public static BigDecimal recCubeRoot(BigDecimal x, int precision) {
        final BigDecimal THREE = new BigDecimal(3.0);
        // 0.01 < |x| < 10.0 ɕWB
        int shift = BDTools.getExp10(x) / 3;
        x = x.movePointLeft(3 * shift);
        /* x 傫Ɖʂ0l߂C appX = x.doubleValue(); Ȃǂ
          Ԃ邽ߐ؂̂ĂB
          x.movePointLeft() Ətɂ appX = NaN G[ɂȂB
        */
        x = BDTools.roundOff(x, precision);
        double appX = x.doubleValue(); 
        if (appX < 0) x = x.negate();   // x = -x

        BigDecimal y = new BigDecimal(Math.pow(Math.abs(appX), -1/3.0)); // x = 0 Ȃ΃G[
        y = BDTools.roundOff(y, DOUBLE_PREC);  // S~
        BigDecimal dy;
        itr = 0;
        dy = x.subtract(new BigDecimal(Math.abs(appX)));  // ߎlƂ̍
        // x = 2.00000....00000123456 ̂悤 dy = O(10^(-p)) ɏꍇ ef = 2 * p ɂƂB
        int ef = 2 * Math.max(DOUBLE_PREC, Math.abs(BDTools.getExp10(dy)));  // x̏l, dy = 0 ̏ꍇl

        do {
            if (ef > precision) ef = precision;
            dy = BDMult.bdMult(y, y, ef);     // dy = y*y
            dy = BDMult.bdMult(y, dy, ef);    // dy = y^3
            dy = BDMult.bdMult(x, dy, ef);    // dy = x * y^3
            dy = BDTools.ONE.subtract(dy);    // dy = 1 - x * y^3
            dy = BDMult.bdMult(y, dy, ef);    // dy = y*(1 - x * y^3)
            dy = dy.divide(THREE, ef, BigDecimal.ROUND_HALF_EVEN); // dy /= 3;
            y = y.add(dy);   ef *= 2;   itr++;
        } while ( (dy.unscaledValue().bitLength() > 8 && itr < ITR_MAX) || ef < precision); // dy != 0 (dy.signum() != 0) ł̓_B

        if (itr == ITR_MAX) {
            System.err.println("\"recCubeRoot\" Ŏ܂B");
            System.exit(-1);
        }
        if (appX < 0)   y = y.negate();
        if (shift != 0) y = y.movePointLeft(shift);
        return y;
    }
    /**
    *<i>x</i> ̗<i>x</i><sup>1/3</sup> ߂܂B
    *@param x <code>BigDecimal <i>x</i></code> ^܂B
    *@param precision x^܂B
    *@return <i>x</i><sup>1/3</sup> Ԃ܂B
    */
    // x^(1/3) = x * /(x*x)^(1/3) ߂
    public static BigDecimal bdCubeRoot(BigDecimal x, int precision) {
        BigDecimal y = BDMult.bdMult(x, x, precision);   // y = x * x

        y = recCubeRoot(y, precision);
        return BDMult.bdMult(x, y, precision);
    }
    /**
    *eXgpFcbrt(2) = 2^(1/3) ͂ŌvZ܂B
    */
    static void getCbrt2(int precision) {
        BigDecimal TWO = new BigDecimal(2.0), cbrt2, d;

        BDTools.precision = precision;
        System.out.println("cbrt(2)  " + precision + " vZ");
        long start = System.currentTimeMillis();
        cbrt2 = bdCubeRoot(TWO, precision);
        long time = System.currentTimeMillis() - start;

        System.out.println("2^(1/3) =");
        BDTools.print(cbrt2, 10);
        System.out.print(" = " + itr + " vZ " + time + " (ms)");
        System.out.println("  o͌ = " + BDTools.decNumber);

        d = TWO.subtract(BDPower.power(cbrt2, 3, precision));
        System.out.println("2 - {2^(1/3)}^3 ̊TZl = " + BDTools.toDoubleString(d));
    }
    public static void main(String[] args) throws IOException {
        System.out.print("1 / {2^(1/3)}  2^(1/3) ߂܂D\nx(>32) ? = ");
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(in.readLine());
        if (n > 32) getCbrt2(n);
    }
}
