/*
* BDMult.java -- {̐
* @version $Revision: 1.8 $, $Date: 2003/03/24 03:37:58 $
* BDTools.java  BITools.java gĂB
*/

import java.math.*;

public class BDMult {
    /**
    *BigDecimal a, b ̐ςʃrbgƉʃrbgɕČvZ܂B
    *ʓm̏Zsv̂ߗ_Iɂ3/4̌vZʂōς݂܂B<br>
    * 10ił̌͒܂܂łB؂̂Ăɂ <code>{@link BDTools#roundOff}</code>
    * gp܂B邢́C{@link BDTools#precision} ɏo͌w肵CBDTools̏o͊֐Ăяo
    *Iɐ؂̂Ă܂B<br>
    *2 iŌvZĂ邽߁CƂ΁C1.0*10<sup>1000</sup> * 1.0*10<sup>-500</sup> 
    *m 1.0*10<sup>500</sup> ɂ͂Ȃ܂B
    *@see BDTools
    *@see BITools
    */
    public static BigDecimal bdMult(final BigDecimal a, final BigDecimal b, int precision) {
        if (a.signum() == 0 || b.signum() == 0) return BDTools.ZERO;
        // L̃rbgB
        int bp = (int)(precision * Math.log(10) / Math.log(2)) + 1;
        BigInteger m = a.unscaledValue(), n = b.unscaledValue(), r;
        int u = bp / 2;
        int scale = a.scale() + b.scale();
        int fm = m.bitLength(), fn = n.bitLength();

        if (fm <= u && fn <= u) { // Zm
            r = BITools.biMult(m, n);
            return new BigDecimal(r, scale);
        }
        if (fm < fn) return bdMult(b, a, precision); // ċA, a ̃rbg>=b̃rbgɂ
        if (m.signum() < 0) m = m.negate();
        if (n.signum() < 0) n = n.negate();
        int shift = 0;
        // ʂ̕svȃrbg؂̂ĂBa܂b߂xȏ̌ꍇɕKvB
        if (fm > bp) {
            m  = m.shiftRight(fm - bp);  shift += fm - bp;
            fm = m.bitLength();
        }
        if (fn > bp) {
            n  = n.shiftRight(fn - bp);  shift += fn - bp;
            fn = n.bitLength();
        }
        // ł́Cfm >= fn, fm > u
        // mnCurbgCʂc̃rbgɕB
        if (fn <= u) { // ƒZ̐, fm > u ̔͗vȂB
            r = BITools.biMult(m, n);
        } else { // m̐
            BigInteger pm = BigInteger.ONE.shiftLeft(fm - u); // pm = 1 << (fm - u);
            pm = pm.subtract(BigInteger.ONE);                 // pm -= 1; pm = 0xfff...f
            BigInteger mL = m.and(pm), mH = m.subtract(mL);
            if (a.equals(b)) { // 2̏ꍇ
                r = BITools.biMult(mH, mH);
                BigInteger lh = BITools.biMult(mL, mH);
                r = r.add(lh.shiftLeft(1)); // r <-- mH^2 + 2 * mL * mH
            } else { // a != b
            // m = mH + mL, n = nH + nL ̌`ɂB
                BigInteger pn = BigInteger.ONE.shiftLeft(fn - u); // pn = 1 << (fn - u);
                pn = pn.subtract(BigInteger.ONE);                 // pn -= 1; pn = 0xfff...f
                BigInteger nL = n.and(pn), nH = n.subtract(nL);
            // ʂ̑̃rbg0łĂBITools.biMult()B
                r = BITools.biMult(mH, nH);
                r = r.add(BITools.biMult(mL, nH));
                r = r.add(BITools.biMult(mH, nL));
            }
        }
        // svȉʃrbg0ɂB
        int sr = r.bitLength() - bp;
        if (sr > 0) { r = r.shiftRight(sr);  r = r.shiftLeft(sr); } // ؂̂
        if (shift != 0) r = r.shiftLeft(shift);  // KKvBƂ܂Ƃ߂͕̂sB
        if (a.signum() * b.signum() < 0) r = r.negate();
        return new BigDecimal(r, scale); // 10ił̌͒2iłbprbgxB
    }
}
