/*
* BDSqrt.java
* @version $Revision: 1.10 $, $Date: 2003/05/12 10:24:55 $
* BDTools.java  BDMult.java gĂB
*/

import java.io.*;
import java.math.*;

/**
*{x̕܂͂̋t߂܂B<br>
*@see BDMult
*@see BDTools
*/

public class BDSqrt {
    public static int itr;
    public static final int ITR_MAX = 20;  // 15 * 2^20 ܂ŁB
    public static final int DOUBLE_PREC = 15; // double ̗L
    /**
    *{x̋̕t <code>1/sqrt(<i>x</i>)</code> ߂܂B<br>
    *߂l10ił̌precision蒷܂܂łi{@link BDMult}jB
    *؂̂Ăɂ <code>BDTools.roundOff(r, precision);</code>
    * gp܂B邢́C{@link BDTools#precision} ɏo͌w肵C
    *BDTools̏o͊֐ĂяoΎIɐ؂̂Ă܂B
    *@param x <code>BigDecimal <i>x</i></code> ^܂B
    *@param precision 10ił̐x^܂B
    *@return <code>1/sqrt(<i>x</i>)</code> Ԃ܂B
    */
    public static BigDecimal recSqrt(BigDecimal x, int precision) {
        final BigDecimal TWO = new BigDecimal(2.0);
        // 1 <= x < 100 ɕWB
        int shift = BDTools.getExp10(x) / 2;
        x = x.movePointLeft(2 * shift);
        /* x 傫Ɖʂ0l߂C appX = x.doubleValue(); Ȃǂ
          Ԃ邽ߐ؂̂ĂB*/
        x = BDTools.roundOff(x, precision);
        double appX  = x.doubleValue();  // double ̋ߎl
        BigDecimal y = new BigDecimal(1.0 / Math.sqrt(appX)), dy; // x <= 0 ̂ƂG[
        y = BDTools.roundOff(y, DOUBLE_PREC);  // S~
        itr = 0;
        dy = x.subtract(new BigDecimal(appX));  // ߎlƂ̍
        // x = 2.00000....00000123456 ̂悤 dy = O(10^(-p)) ɏꍇ ef = 2 * p ɂƂB
        int ef = 2 * Math.max(DOUBLE_PREC, Math.abs(BDTools.getExp10(dy)));  // x̏l, dy = 0 ̏ꍇl

        do {
            if (ef > precision) ef = precision;
            // dy = y*(1-x*y^2)
            dy = BDMult.bdMult(y, y, ef);     // dy = y*y
            dy = BDMult.bdMult(x, dy, ef);    // dy *= x
            dy = BDTools.ONE.subtract(dy);    // dy = 1 - dy
            dy = BDMult.bdMult(y, dy, ef);    // dy *= y
         // dy /= 2 mӁndy *= 0.5 ƏZɂƐxwłȂ dy = 0 ɂȂȂB
         // ܂C dy ̌vZŗL𐔌(4`8x)₳Ȃƌ덷ŐUĎȂB
            dy = dy.divide(TWO, ef, BigDecimal.ROUND_HALF_EVEN);
            y = y.add(dy);   ef *= 2;  itr++;
        } while ( (dy.unscaledValue().bitLength() > 8 && itr < ITR_MAX) || ef < precision); // dy != 0 (dy.signum() != 0) ł̓_B

        if (itr == ITR_MAX) {
            System.err.println("\"recSqrt\" Ŏ܂B");
            System.exit(-1);
        }
        if (shift != 0) y = y.movePointLeft(shift);
        return y;
    }
    /**
    *{x̕ <code>sqrt(<i>x</i>)</code> ߂܂B
    *@param x <code>BigDecimal <i>x</i></code> ^܂B
    *@param precision x^܂B
    *@return <code>sqrt(<i>x</i>)</code> Ԃ܂B
    */
    public static BigDecimal bdSqrt(BigDecimal x, int precision) {
        return BDMult.bdMult(recSqrt(x, precision), x, precision);
    }
    /**
    *eXgpFsqrt(2) ͂ŌvZ܂B
    */
    static void getSqrt2(int precision) {
        BigDecimal TWO = new BigDecimal(2.0), sqrt2, d;

        BDTools.precision = precision;
        System.out.println("sqrt(2)  " + precision + " vZ");
        long start = System.currentTimeMillis();
        sqrt2 = bdSqrt(TWO, precision);
        long time = System.currentTimeMillis() - start;

        System.out.println("sqrt(2) =");
        BDTools.print(sqrt2, 10);
        System.out.print(" = " + itr + " vZ " + time + " (ms)");
        System.out.println("  o͌ = " + BDTools.decNumber);
        d = TWO.subtract(BDMult.bdMult(sqrt2, sqrt2, precision));
        System.out.println("2 - sqrt(2)^2 ̊TZl = " + BDTools.toDoubleString(d));
    }
    public static void main(String[] args) throws IOException {
        System.out.print("1 / sqrt(2)  sqrt(2) ߂܂D\nx(>32) ? = ");
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(in.readLine());
        if (n > 32) getSqrt2(n);
    }
}
