/*
* BDTools.java -- BigDecimal W
* @version $Revision: 1.15 $, $Date: 2003/03/26 14:35:33 $
* {ɂ͏o͊֌WȂǂ͍ڂB
*/
import java.math.*;
import java.util.*;
import java.io.*;

/**
*BigDecimal ̏W񋟂܂B
* @see BDtoE_Form
*/
public class BDTools {
    /**
    *10 ił̏o͌ێĂ܂B
    */
    public static int decNumber;
    /**
    *10 ił̏o͌wł܂BȂ킿Co͂ƂCprecision + 1 ڂľܓ܂B
    */
    public static int precision = -1;
    /**
    * {@link #getExp10}Ă΂ꂽƂ̉ێĂ܂B
    */
    public static double mant;
    /**
    *BigDecimal 萔 0.0 łB
    */
    public static final BigDecimal ZERO = new BigDecimal(0.0);
    /**
    *BigDecimal 萔 1.0 łB
    */
    public static final BigDecimal ONE  = new BigDecimal(1.0);
    /**
    *BigDecimal 萔 10.0 łB
    */
    public static final BigDecimal TEN = new BigDecimal(10.0);
    private static long seed = System.currentTimeMillis();
    /**
    * dec Ő 1.0 菬Ԃ܂B
    */
    public static BigDecimal random(int dec) {
        int bits = (int)(dec * Math.log(10.0) / Math.log(2.0));
        Random     rnd  = new Random(seed++);
        BigInteger mant = new BigInteger(bits, rnd);
        BigDecimal bd   = new BigDecimal(mant, biFig10(mant));

        while (bd.compareTo(ONE) > 0) bd = bd.movePointLeft(1); // ܂ɂsȂB
        return bd;
    }
    /**
    * ʂ 0 łȂrbgԂ܂B<br>
    * <b></b><code> 1100 0101 1010 0000 0000</code> ł 11 Ԃ܂B
    */
    public static int nonZeroBitLength(BigDecimal x) {
        BigInteger u = x.unscaledValue();
        return u.bitLength() - u.getLowestSetBit();
    }
    /**
    * ̏(place + 1)ʂŊۂ߂܂B
    */
    public static BigDecimal roundOff(BigDecimal x, int place, int roundingMode) {
        int e = getExp10(x);

        x = x.movePointLeft(e);
        x = x.divide(ONE, place, roundingMode);  // 1 ŊĂB
        return x.movePointRight(e);
    }
    /**
    * (place + 1)ʂŎľܓ܂B
    */
    public static BigDecimal roundOff(BigDecimal x, int place) {
        return roundOff(x, place, BigDecimal.ROUND_HALF_UP);
    }
    /**
    * (place + 1)ʈȉ؂̂Ă܂B
    */
    public static BigDecimal roundDown(BigDecimal x, int place) {
        return roundOff(x, place, BigDecimal.ROUND_DOWN);
    }
    /**
    * BigInteger r  10 i\ł̌̊TZl߂܂B
    */
    public static int biFig10(BigInteger r) {
        return (int)(r.bitLength() * Math.log(2) / Math.log(10)) + 1;
    }
    /**
    * BigDecimal x  10 i\ł̗L̊TZl߂܂Bʂ 0 ܂݂܂B
    */
    public static int bdEffFig10(BigDecimal x) {
        return biFig10(x.unscaledValue());
    }
    private static final int DOUBLE_PREC = 15; // double ̗L
    /**
    * BigDecimal x  double m (1.0|m|10.0)p<b>m~10<sup>e</sup></b>
    *`ɕϊƂ̎w e ̒lԂ܂B m  {@link #mant} ێĂ܂B<br>
    *BigDecimal ̉Kvȏꍇ̓NX {@link BDtoE_Form} g܂B
    * @return w e
    */
    public static int getExp10(BigDecimal x) {
        if (x.signum() == 0) { mant = 0;  return 0; }
        int exp = biFig10(x.unscaledValue()) - x.scale() - 1;
        BigDecimal mx = x.movePointLeft(exp), tm = mx;  // mx Fx ̉̉
    // ƉdoubleValue()ɎԂ邽ߐ؂̂ĂB
        tm = tm.divide(ONE, DOUBLE_PREC * 2, BigDecimal.ROUND_HALF_UP);  // 1 ŊĂB
        mant = tm.doubleValue();
        // w̒
        double p = Math.abs(mant);
        if (p == 1.0 || p == 10.0) { // |x| 1܂10ɋ߂lꍇB
            if (x.signum() < 0) mx = mx.negate();
            while (mx.compareTo(ONE) < 0) {
                mant *= 10.0;  mx = mx.movePointRight(1);  exp--;
            }
            while (mx.compareTo(TEN) >= 0) {
                mant /= 10.0;  mx = mx.movePointLeft(1);   exp++;
            }
        } else {
            while (Math.abs(mant) < 1.0)  { mant *= 10.0; exp--; }
            while (Math.abs(mant) > 10.0) { mant /= 10.0; exp++; }
        }
        return exp;
    }
    /**
    *BigDecimal a, b ̐ςʃrbgƉʃrbgɔɕČvZ܂B<br>
    *{@link BDMult#bdMult}ĂяoĂ܂B
    */
    public static BigDecimal bdMult(BigDecimal a, BigDecimal b, int precision) {
        return BDMult.bdMult(a, b, precision);
    }
    /**
    * BigDecimal x  <code><b>[+|-]a.bcd...e[+|-]xxx</b></code> `ɕϊԂ܂B
    * TZlo͂ꍇȂǂɎg܂B
    * x.doubleValue(); ł̓A_[^I[o[t[ꍇ邽߂ɑĂ܂B
    */
    public static String toDoubleString(BigDecimal x) {
        if (x.signum() == 0) return new String("0.0");
        int exp = getExp10(x);

        return Double.toString(mant) + "e" + Integer.toString(exp);
    }

    /**
    * BigDecimal x  p ؂ <code><b>[+|-]a.bcd...E[+|-]xxx</b></code> `ŏo͂܂B
    * 2ił̃rbgZĂ10ił̂ꂪꍇ͏o͂̑O<br>
    *<code>x = BDTools.roundOff(x, precision);</code><br>
    *sĂB
    * @param newLine sďo͂ꍇ true ^܂B
    * @return 10 i\ł̏o͌Ԃ܂B
    */
    public static int print(BigDecimal x, int p, boolean newLine) {
        System.out.println(toE_FormString(x, p, newLine));
        return decNumber;
    }
    /**
    * BigDecimal x  p ؂ <code><b>[+|-]a.bcd...E[+|-]xxx</b></code> `ŏo͂܂B
    * o͂Ɖs܂B
    * @return 10 i\ł̏o͌Ԃ܂B
    */
    public static int print(BigDecimal x, int p) {  return print(x, p, true); }
    /**
    * BigDecimal x  p ؂ <code><b>[+|-]a.bcd... e[+|-]xxx</b></code> `̕ɕϊ܂B
    *  0 ͏Co͂Ɖs܂B<br>
    * Cp  0 ɂƋ󔒂sꂸĈ܂ BigDecimal ̃RXgN^
    * public BigDecimal(String val)  val Ɏgpł܂B
    * 10 i\ł̌ BDTools.decNumber ɓĂ܂B
    */
    public static String toE_FormString(BigDecimal x, int p) { return toE_FormString(x, p, true); }
    /**
    * BigDecimal x  p ؂ <code><b>[+|-]a.bcd...E[+|-]xxx</b></code> `̕ɕϊ܂B
    *  0 ͏܂Bp  0 ɂƋ󔒂sꂸĈ܂ BigDecimal ̃RXgN^
    * public BigDecimal(String val)  val Ɏgpł܂B
    * @param newLine sďo͂ꍇ true ^܂B<br>
    * Cp 傫ꍇ x Z̏ꍇ p  newLine ̎w͖܂B
    */
    public static String toE_FormString(BigDecimal x, int p, boolean newLine) {
        decNumber = 0;
        if (x.signum() == 0) return new String("0.0");
        if (precision > 0) x = roundOff(x, precision);

        int notNum = x.signum() > 0 ? 1 : 2;   //  '-' ̗LƏ_ '.'
        BDtoE_Form bdE = new BDtoE_Form(x); // BDtoE_Form.java ɂB 0 ܂łB
        int    exp  = bdE.exp();    // w
        double mant = bdE.mant();   // (double)
        BigDecimal xMant = bdE.bdMant();    // (BigDecimal)

        if (xMant.compareTo(new BigDecimal(mant)) == 0) { // bdEffFig10(x) < 16 ̔͂߁B
            // x == mant, "2.0" ȂǉssvȒZ̏ꍇB
            String s = Double.toString(mant);   // 1.0 <= mant < 10.0 ł邩 s ɂ͎w Ennn ͕tĂȂB
            decNumber = s.length() - notNum;

            return s + "E" + Integer.toString(exp);
        }

        String s = xMant.toString();
        if (p > s.length() || p <= 0) {
            decNumber = s.length() - notNum;
        // BigDecimal ̃RXgN^ BigDecimal(String) Ɏgp\ɂ邽 " E" Ƃ͂ȂB
            return s + "E" + Integer.toString(exp);
        }
        char r[] = s.toCharArray();
        final char DELMT = ' ';  // ؂蕶
        int decLen = r.length;
        StringBuffer sb = new StringBuffer(decLen); // Iɗeʂ
        int i = 0;

        do {    // CC_
            sb.append(r, i, 1);     decLen--;
        } while (r[i++] != '.');

        if (newLine) sb.append("+\n");

        int iRem = decLen % p, iMax = i + decLen - iRem;    // (iMax - i)  p ̔{

        for (; i < iMax; i += p) {
            sb.append(r, i, p); sb.append(DELMT);
        }
        if (iRem != 0){
            sb.append(r, i, iRem);  i += iRem;
        }
        decNumber = i - notNum;
        int last = sb.length() -1;
        if (sb.charAt(last) == DELMT) sb.deleteCharAt(last);  // Ō̕؂蕶Ȃ폜B
        // wǉC͌₷悤 " E" ƂB
        //  readNumber() œǂݍ݉\B
        return sb.toString() + " E" + Integer.toString(exp);
    }
    /**
    * QBigDecimal a, b v邩Ԃ܂B
    */
    public static int agreeUpTo(BigDecimal a, BigDecimal b) {
        BDtoE_Form bdeA = new BDtoE_Form(a);
        BDtoE_Form bdeB = new BDtoE_Form(b);
        if (bdeA.exp() != bdeB.exp()) return 0; // if ( a.scale() != b.scale()) return 0; ł͂߁B

        char[] sa = bdeA.bdMant().toString().toCharArray();
        char[] sb = bdeB.bdMant().toString().toCharArray();
        int num = 0, iMax = Math.min(sa.length, sb.length);

        for (int i = 0; i < iMax && sa[i] == sb[i]; i++)
            if (Character.isDigit(sa[i])) num++;
        return num;
    }

    private static boolean skip(int c) {
        return c == ' ' || c == '\r' || c == '\n' || c == '+';
    }
    /**
    * BigDecimal lt@Cǂݍ݂܂Bprecision ɂ 10 ił̌^܂B
    * ۂɓǂݍ񂾌 {@link #decNumber} ɓĂ܂B
    * precision 傫ꍇ decNumber &lt; precision ƂȂ܂B<br>
    * l̓rɉsC󔒂'+'LĂĂ܂܂B
    *@param fileName ̓t@C^܂B
    *@return ǂݍ BigDecimal lԂ܂Bt@CȂꍇ <code>null</code> Ԃ܂B
    */
    public static BigDecimal readNumber(String fileName, int precision) throws IOException {
        BufferedReader in;
        try { in = new BufferedReader(new FileReader(fileName));
        } catch (FileNotFoundException e) { return null; }
        StringBuffer sb = new StringBuffer();
        int c, len = 0;

        do { //  "[+|-]a."
            if ((c = in.read()) == -1) break;
            sb.append((char)c);
            if (Character.isDigit((char)c)) len++;
        } while (len < precision && c != '.');

        while (c != -1 && len < precision) { //  "bcdef..."
            c = in.read();
            if (c == 'e' || c == 'E') break;
            if (Character.isDigit((char)c)) {
                sb.append((char)c); len++;
            }
        }

        if (c != -1) { // w "E[+|-]xyz" TB
            while (c != 'e' && c != 'E' && c != -1) c = in.read();
            while (c != -1 && !skip(c)) {
                sb.append((char)c); c = in.read();
            }
        }
        in.close();
        decNumber = len;
        return new BigDecimal(sb.toString());
    }
}
