/**
 *  Bisection.java -- 2@(bisection method)
 *
 *  @version $Revision: 1.10 $, $Date: 2003/04/05 15:10:00 $
 */

public class Bisection {
    /** _߂֐ f(x) */
    public interface Function {  public double of(double x);  }

    /** Ȃ^ */
    private static boolean isSameSign(double a, double b) {
        return (a > 0) == (b > 0);
    }

    /** f(x) = 0 ̉ [a,b] 狖e덷 tolerance ŋ߂ */
    public static double solve(Function f, double a, double b,
                               double tolerance) {
        if (tolerance < 0) tolerance = 0;
        if (b < a) {  double swap = a;  a = b;  b = swap;  }
        double fa = f.of(a);  if (fa == 0) return a;
        double fb = f.of(b);  if (fb == 0) return b;
        if (isSameSign(fa, fb))
            throw new Error("Ԃ̗[Ŋ֐lłB");
        for ( ; ; ) {
            double c = (a + b) / 2;
            if (c - a <= tolerance || b - c <= tolerance) return c;
            double fc = f.of(c);  if (fc == 0) return c;
            if (isSameSign(fc, fa)) {  a = c;  fa = fc;  }
            else                    {  b = c;  fb = fc;  }
        }
    }
}
