/**
 *  fxNgNXF
 *
 *  fxNg(Complex ̔z)ɑ΂e퉉Z\bh񋟂܂B
 *
 *  @version $Revision: 1.6 $, $Date: 2003/03/13 14:24:30 $
 */
public class CVector {
    /**
     *  fxNgԂ܂B
     *  @return v<sup>*</sup>
     */
    public static Complex[] conj(Complex[] v) {
        Complex[] ret = new Complex[v.length];
        for (int i = 0; i < v.length; i++) ret[i] = v[i].conj();
        return ret;
    }
    /**
     *  l (lhs + rhs) ƂȂxNgԂ܂B
     *  @param  lhs 
     *  @param  rhs E
     *  @return (lhs + rhs)
     */
    public static Complex[] add(Complex[] lhs, Complex[] rhs) {
        if (lhs.length != rhs.length)
            throw new IndexOutOfBoundsException();
        Complex[] ret = new Complex[lhs.length];
        for (int i = 0; i < lhs.length; i++) ret[i] = lhs[i].add(rhs[i]);
        return ret;
    }
    /**
     *  l (this - rhs) ƂȂxNgԂ܂B
     *  @param  rhs ̃xNgɉl
     *  @return (this - rhs)
     */
    public static Complex[] subtract(Complex[] lhs, Complex[] rhs) {
        if (lhs.length != rhs.length)
            throw new IndexOutOfBoundsException();
        Complex[] ret = new Complex[lhs.length];
        for (int i = 0; i < lhs.length; i++) ret[i] = lhs[i].subtract(rhs[i]);
        return ret;
    }
    /**
     *  l (z * v) ƂȂxNgԂ܂B
     *  @param  z   XJ[
     *  @param  v   xNg
     *  @return (z * v)
     */
    public static Complex[] multiply(Complex z, Complex[] v) {
        Complex[] ret = new Complex[v.length];
        for (int i = 0; i < v.length; i++) ret[i] = z.multiply(v[i]);
        return ret;
    }
    /**
     *  lhs[ns]<sup>*</sup>*rhs[ns]+..+
     *  lhs[ne-1]<sup>*</sup>*rhs[ne-1] Ԃ܂B
     *  @param  ns  aŏ̗vfԍ
     *  @param  ne  aŌ̗vf̗̎vfԍ
     *  @param  lhs 
     *  @param  rhs E
     *  @return Ž
     */
    public static Complex innerProduct(int ns, int ne,
                                       Complex[] lhs, Complex[] rhs) {
        if (ns < 0 || ne < 0 || ns > ne) throw new IndexOutOfBoundsException();
        double re = 0.0, im = 0.0;
        for (int i = ns; i < ne; i++) {
            Complex value = lhs[i].conj().multiply(rhs[i]);
            re += value.re(); im += value.im();
        }
        return new Complex(re,im);
    }
    /**
     *  xNg ns Ԗڂ̗vfŌ̗vf܂ł̓ςԂ܂B
     *  @param  ns  aŏ̗vfԍ
     *  @param  lhs 
     *  @param  rhs E
     *  @return ς̒l
     */
    public static Complex innerProduct(int ns, Complex[] lhs, Complex[] rhs) {
        return innerProduct(ns, lhs.length, lhs, rhs);
    }
    /**
     *  xNg̓ςԂ܂B
     *  @param  lhs 
     *  @param  rhs E
     *  @return ς̒l
     */
    public static Complex innerProduct(Complex[] lhs, Complex[] rhs) {
        return innerProduct(0, lhs.length, lhs, rhs);
    }
}

