/**
 *  fNXF
 *
 *  fyтɑ΂e퉉Z\bh񋟂܂B
 *  E̓\yѐlZ͑S double ^pĂ܂B
 *
 *  @version $Revision: 1.8 $, $Date: 2003/03/13 14:24:30 $
 */
public class Complex {
    private double real, imag;
    /**
     *  C^ĕfIuWFNg쐬
     *
     *  @param  real    
     *  @param  imag    
     */
    public Complex(double real, double imag) {
        this.real = real; this.imag = imag;
    }
    /**
     *  C 0 ƂĕfIuWFNg쐬
     */
    public Complex() { this(0.0,0.0); }
    /**
     *  Rs[RXgN^
     *
     *  @param  that    Rs[̕fIuWFNg
     */
    public Complex(Complex that) {
        if (that != null) { real = that.real; imag = that.imag; }
    }
    /**
     *  f "<code><i>re</i>+<i>im</i>i</code>" Ƃɕϊ܂B
     *  @return f̕\
     */
    public String toString() {
        if (imag >= 0) return real + "+" + imag + "i";
        return real + "-" + Math.abs(imag) + "i";
    }
    /**
     *  fm̔r܂B
     *
     *  @param  rhs rΏۃIuWFNgB
     *  @return rhs  Complex wCCɓꍇ
     *          true Ԃ܂B
     */
    public boolean equals(Object rhs) {
        if (this == rhs) return true;
        if (rhs instanceof Complex)
            return (real == ((Complex)rhs).real &&
                    imag == ((Complex)rhs).imag);
        return false;
    }
    /**
     *  Ԃ܂B
     *  @return Re(this)
     */
    public double re() { return real; }
    /**
     *  Ԃ܂B
     *  @return Im(this)
     */
    public double im() { return imag; }

    //  ȉ̂Q̃\bh static ł悩H

    /**
     *  ΒlԂ܂B
     *  @return |this|
     */
    public double abs() {
        if (real == 0) return imag;
        if (imag == 0) return real;
        if (Math.abs(imag) > Math.abs(real)) {
            double  t = real / imag;
            return Math.abs(imag) * Math.sqrt(1 + t * t);
        } else {
            double  t = imag / real;
            return Math.abs(real) * Math.sqrt(1 + t * t);
        }
    }
    /**
     *  ʑ - <  <  ͈̔͂ŕԂ܂B
     *  @return Arg(this)
     */
    public double arg() { return Math.atan2(imag,real); }
    /**
     *  ׂ
     *  @param  z   w
     *  @return this<sup>z</sup> = exp(z log(this))
     */
    public Complex pow(Complex z) {
        return Complex.exp(z.multiply(Complex.log(this)));
    }

    //  lZ
    /**
     *  l (this + rhs) ̕fԂ܂B
     *  @param  rhs ̕fɉl
     *  @return this + rhs
     */
    public Complex add(Complex rhs) {
        return new Complex(real + rhs.real, imag + rhs.imag);
    }
    /**
     *  l (this - rhs) ̕fԂ܂B
     *  @param  rhs ̕fl
     *  @return this - rhs
     */
    public Complex subtract(Complex rhs) {
        return new Complex(real - rhs.real, imag - rhs.imag);
    }
    /**
     *  l (this * rhs) ̕fԂ܂B
     *  @param  rhs ̕fɂl
     *  @return this * rhs
     */
    public Complex multiply(Complex rhs) {
        return new Complex(
                            real * rhs.real - imag * rhs.imag,
                            real * rhs.imag + imag * rhs.real
                        );
    }
    /**
     *  l (this / rhs) ̕fԂ܂B
     *  @param  rhs ̕fl
     *  @return this / rhs
     */
    public Complex divide(Complex rhs) {
        if (Math.abs(rhs.real) >= Math.abs(rhs.imag)) {
            double  w = rhs.imag / rhs.real,
                    d = rhs.real + rhs.imag * w;
            return new Complex((real + imag * w) / d, (imag - real * w) / d);
        } else {
            double  w = rhs.real / rhs.imag,
                    d = rhs.real * w + rhs.imag;
            return new Complex((real * w + imag) / d, (imag * w - real) / d);
        }
    }
    /**
     *  f
     *  @return this<sup>*</sup>
     */
    public Complex conj() { return new Complex(real,-imag); }
    /**
     *  -1 {
     *  @return -this
     */
    public Complex negate() { return new Complex(-real,-imag); }

    //  ֐
    /**
     *  w֐
     *  @param  z   Z̑Ώ
     *  @return exp(z) = exp(x) * (cos y + i sin y)
     */
    public static Complex exp(Complex z) {
        double  a = Math.exp(z.real);
        return new Complex(a * Math.cos(z.imag), a * Math.sin(z.imag));
    }
    /**
     *  ΐ֐
     *  @param  z   Z̑Ώ
     *  @return log(z) = log r + i 
     */
    public static Complex log(Complex z) {
        return new Complex(
                        0.5 * Math.log(z.real * z.real + z.imag * z.imag),
                        Math.atan2(z.imag,z.real)
                    );
    }
    /**
     *  ֐
     *  @param  z   Z̑Ώ
     *  @return sin(z)
     */
    public static Complex sin(Complex z) {
        double  e = Math.exp(z.imag), f = 1 / e;
        return new Complex(
                        0.5 * Math.cos(z.real) * (e - f),
                        0.5 * Math.sin(z.real) * (e + f)
                    );
    }
    /**
     *  ]֐
     *  @param  z   Z̑Ώ
     *  @return cos(z)
     */
    public static Complex cos(Complex z) {
        double  e = Math.exp(z.imag), f = 1 / e;
        return new Complex(
                        0.5 * Math.cos(z.real) * (f - e),
                        0.5 * Math.sin(z.real) * (f + e)
                    );
    }
    /**
     *  ڊ֐
     *  @param  z   Z̑Ώ
     *  @return tan(z)
     */
    public static Complex tan(Complex z) {
        double  e = Math.exp(2 * z.imag), f = 1 / e,
                d = Math.cos(2 * z.real) + 0.5 * (e + f);
        return new Complex(
                        Math.sin(2 * z.real) / d,
                        0.5 * (e - f) / d
                    );
    }
    /**
     *  oȐ֐
     *  @param  z   Z̑Ώ
     *  @return sinh(z)
     */
    public static Complex sinh(Complex z) {
        double  e = Math.exp(z.real), f = 1 / e;
        return new Complex(
                        0.5 * Math.cos(z.imag) * (e - f),
                        0.5 * Math.sin(z.imag) * (e + f)
                    );
    }
    /**
     *  oȗ]֐
     *  @param  z   Z̑Ώ
     *  @return cosh(z)
     */
    public static Complex cosh(Complex z) {
        double  e = Math.exp(z.real), f = 1 / e;
        return new Complex(
                        0.5 * Math.cos(z.imag) * (e + f),
                        0.5 * Math.sin(z.imag) * (e - f)
                    );
    }
    /**
     *  oȐڊ֐
     *  @param  z   Z̑Ώ
     *  @return tanh(z)
     */
    public static Complex tanh(Complex z) {
        double  e = Math.exp(2 * z.real), f = 1 / e,
                d = Math.cos(2 * z.imag) + 0.5 * (e + f);
        return new Complex(
                        0.5 * (e - f) / d,
                        Math.sin(2 * z.imag) / d
                    );
    }
    private static final double SQRT05 = 0.707106781186547524;
    /**
     *  
     *  @param  z   Z̑Ώ
     *  @return z<sup>1/2</sup>
     */
    public static Complex sqrt(Complex z) {
        double  r = z.abs(), w = Math.sqrt(r + Math.abs(z.real));
        if (z.real >= 0) {
            return new Complex(SQRT05 * w, SQRT05 * z.imag / w);
        } else {
            return new Complex(
                            SQRT05 * Math.abs(z.imag) / w,
                            (z.imag >= 0) ? SQRT05 * w : -SQRT05 * w
                        );
        }
    }

    /**
     *  B̃Gg|Cg
     *  @param  args    --
     */
    public static void main(String[] args) {
        //  Zp󂯎Čʂ\悤ɂĂB
        Complex z = new Complex(1.0,1.0), w = new Complex(2.0,-3.0);
        System.out.print(
                    "z = " + z + "\n" + 
                    "w = " + w + "\n" + 
                    "z + w = " + z.add(w) + "\n" + 
                    "z - w = " + z.subtract(w) + "\n" + 
                    "z * w = " + z.multiply(w) + "\n" + 
                    "z / w = " + z.divide(w) + "\n" + 
                    "|z| = " + z.abs() + "\n" + 
                    "Arg(z) = " + z.arg() + "\n" + 
                    "z^w = " + z.pow(w) + "\n" + 
                    "z^* = " + z.conj() + "\n" + 
                    "-z = " + z.negate() + "\n" + 
                    "exp(z) = " + Complex.exp(z) + "\n" + 
                    "log(z) = " + Complex.log(z) + "\n" + 
                    "sin(z) = " + Complex.sin(z) + "\n" + 
                    "cos(z) = " + Complex.cos(z) + "\n" + 
                    "tan(z) = " + Complex.tan(z) + "\n" + 
                    "sinh(z) = " + Complex.sinh(z) + "\n" + 
                    "cosh(z) = " + Complex.cosh(z) + "\n" + 
                    "tanh(z) = " + Complex.tanh(z) + "\n" + 
                    "z^(1/2) = " + Complex.sqrt(z) + "\n"
                );
    }
}

