/*
 *    $Revision: 1.8 $, $Date: 2003/04/28 23:23:15 $
 *    DHP(Diffie-Hellman problem)̍𗘗pL@
 */
import java.math.BigInteger;

class DHKeySharing {
    // SĂ̌[Uɋ
    private static final BigInteger g;  // n
    private static final BigInteger p;  // f

    // e[U̔閧ƌJ
    private final BigInteger privateKey;
    public final BigInteger publicKey;

    public DHKeySharing(BigInteger privateKey) {
        this.privateKey = privateKey;
        publicKey = g.modPow(privateKey, p);
    }
/*
    // base^index mod g vZ
    // modPow ̈̎
    private static BigInteger power(BigInteger base, BigInteger index) {
        int bitLength = index.bitLength();
        BigInteger ret = BigInteger.ONE;
        for (int i = 0; i < bitLength; i++) {

            if ((index.intValue() & 1) == 1) {
                ret = ret.multiply(base);
                if (ret.compareTo(p) >= 0) {
                    ret = ret.mod(p);
                }
            }
            index = index.shiftRight(1);
            base = base.multiply(base);
            if (base.compareTo(p) >= 0) {
                base = base.mod(p);
            }
        }
        return ret;
    }
*/
    // L
    public BigInteger getCommonKey(DHKeySharing other) {
        return other.publicKey.modPow(privateKey, p);
    }
    // mod p ł̌n g 1Œ
    static {
        g = new BigInteger("3");
        p = new BigInteger("1000000000000000000000000000057");
    }

    public static void main(String[] args) {
        DHKeySharing alice = new DHKeySharing(BigInteger.valueOf(1234));
        DHKeySharing bob   = new DHKeySharing(BigInteger.valueOf(5678));

        System.out.println("alice.publicKey  = " + alice.publicKey);
        System.out.println("bob.publicKey    = " + bob.publicKey);
        System.out.println("alice common key = " + alice.getCommonKey(bob));
        System.out.println("bob   common key = " + bob.getCommonKey(alice));
    }
}
