/**
 *  ŒZH
 *  gp: java Dijkstra <Dijkstra.dat
 *
 *  @version $Revision: 1.8 $, $Date: 2003/03/02 14:10:24 $
 */

import java.io.*;
import java.util.*;

public class Dijkstra {
    // f[^
    private static int[][] readWeight() throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        String s = in.readLine();
        StringTokenizer t = new StringTokenizer(s);
        final int n = Integer.parseInt(t.nextToken());

        int[][] weight = new int[n][n];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                weight[i][j] = Integer.MAX_VALUE;

        while ((s = in.readLine()) != null) {
            t = new StringTokenizer(s);
            int i = Integer.parseInt(t.nextToken());
            int j = Integer.parseInt(t.nextToken());
            weight[i][j] = weight[j][i] =
                Integer.parseInt(t.nextToken());
        }

        System.out.println("f[^ weight(i,j)");
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (weight[i][j] < Integer.MAX_VALUE) {
                    s = "   " + weight[i][j];
                    s = s.substring(s.length() - 4);
                } else {
                    s = "  ";
                }
                System.out.print(s);
            }
            System.out.println();
        }
        return weight;
    }

    static final int START = 0; // o_

    public static void main(String[] args) throws IOException {
        int[][] weight = readWeight(); //  weight[0..n-1][0..n-1] ǂ
        final int n = weight.length;
        boolean[] visited = new boolean[n];
        int[] distance = new int[n];
        int[] prev = new int[n];
        for (int i = 0; i < n; i++) {
            visited[i] = false;  distance[i] = Integer.MAX_VALUE;
        }

        distance[START] = 0;
        int next = START;
        int min;
        do {
            final int i = next;
            visited[i] = true;
            min = Integer.MAX_VALUE;
            for (int j = 0; j < n; j++) {
                if (visited[j]) continue;
                if (weight[i][j] < Integer.MAX_VALUE &&
                    distance[i] + weight[i][j] < distance[j]) {
                    distance[j] = distance[i] + weight[i][j];
                    prev[j] = i;
                }
                if (distance[j] < min) {
                    min = distance[j];  next = j;
                }
            }
        } while (min < Integer.MAX_VALUE);

        System.out.println("_  O̓_  ŒZ");
        for (int i = 0; i < n; i++) {
            if (i == START || !visited[i]) continue;
            System.out.println(i + " " + prev[i] + " " + distance[i]);
        }
    }
}
