/*
* FFTMult.java -- FFT Z
* @version $Revision: 1.7 $, $Date: 2003/01/26 05:45:34 $
* 10,000̑{NX SInteger gp
*/
import java.math.*;
import java.util.*;
import java.io.*;

/**
* FFT Z̃eXgEvOłB
* @see BDTools
* @see SInteger
*/

public class FFTMult {
    static final double EPS = 0.25;
    /**
    * SInteger a, b ^ a  b ̐ςԂ܂B
    * @see SInteger
    */
    public static SInteger getValue(SInteger a, SInteger b) {
        int N = SInteger.ceilpow2(Math.max(a.size, b.size)) * 2, i;
        FFT fftN = new FFT(N);
        double xr[] = new double[N];    // 0 ɏ
        double xi[] = new double[N];
        double yr[] = new double[N];
        double yi[] = new double[N];
        double zr[] = new double[N];
        double zi[] = new double[N];

        for (i = 0; i < a.size ; i++) xr[i] = a.f[i];
        for (i = 0; i < b.size ; i++) yr[i] = b.f[i];
        fftN.fft(xr, xi);   fftN.fft(yr, yi);  // FFT
/* ς̌vZ
* ߖ̂߂ xr[], xi[] ɏ㏑邱ƂłB
* double xR = xr[i] * yr[i] - xi[i] * yi[i];
* double xI = xr[i] * yi[i] + xi[i] * yr[i];
* xr[i] = xR;   xi[i] = xI;
*/
        for (i = 0; i < N; i++) {
            zr[i] = xr[i] * yr[i] - xi[i] * yi[i];
            zi[i] = xr[i] * yi[i] + xi[i] * yr[i];
        }
        fftN.ifft(zr, zi);  // tFFT

        SInteger r = new SInteger(N);
        // K uJava  long ̌ > double ̗Lvł邱ƂgĂB
        // long  32 rbg̏ꍇ double gKvB
        for (i = 0; i < N - 1; i++) {
            long w = (long)(zr[i] + EPS); // double 𐮐lɊۂ߂
            r.f[i] = (short)(w % SInteger.RADIX); // ]̌Ɏc
            zr[i + 1] += w / SInteger.RADIX; // Jオ
        }
        r.f[i] = (short)(zr[i] + EPS);  // ŏʂ̌
        return r;
    }
/**
*eXgvOłB<br>
*10,000ł̌ n ͂ƁCFFT Z BigInteger ŽvZʂ
*x̔rs܂Bn = 10,000 xɂ FFT Z̕{Ƃ
*܂B
* @see BITools
*/
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));

        System.out.print("^S = ");
        int fig = Integer.parseInt(in.readLine());  fig = SInteger.ceilpow2(fig);
        if (fig <= 0) {
            System.err.println("̐l͂ĂB"); System.exit(-1);
        }
        SInteger siA = new SInteger(fig);
        SInteger siB = new SInteger(fig);
        SInteger siC = new SInteger(0);

        System.out.println( (fig * SInteger.FIGURES) + " ̗쐬");
        siA.setRandom(fig);     siB.setRandom(fig);
        System.out.println("SInteger --> BigInteger ϊ");

        BigInteger a = siA.toBigInteger();
        BigInteger b = siB.toBigInteger();

        System.out.println("\na = ");   BITools.print(a, 10);
        System.out.println("\nb = " + BITools.toDelimiterString(b, 10) + '\n');

        System.out.println("BigInteger Z");
        long start = System.currentTimeMillis();
        BigInteger c = a.multiply(b); // c = a * b
        long tBD = System.currentTimeMillis() - start;
        System.out.println("result of a.multiply(b) =\n");
        BITools.print(c, SInteger.FIGURES);

        System.out.println("\nFFT Z");
        start = System.currentTimeMillis();
        siC = getValue(siA, siB);
        long tFFT = System.currentTimeMillis() - start;
        System.out.println("result of getValue(a, b) =");    siC.print();

        System.out.println("SInteger --> BigInteger ϊ");
        BigInteger d = siC.toBigInteger();
        int dig = BDTools.biFig10(d);

        d = d.subtract(c);  // d -= c
        System.out.println("c - d = " + d + " <== 0 ɂȂ͂");

        System.out.println("Z 10 ǐ̊TZl : " + dig +
            "\nvZ BigInteger Z : " + tBD + "(ms)" + "  FFT Z : " + tFFT + "(ms)");
    }
}
