import java.applet.*;
import java.awt.*;
import java.util.StringTokenizer;

abstract public class FuncViewer extends Applet {
    //  `̈̃TCY(sNZP)
    private static int XMAX = 640, YMAX = 400;
    //  vbgA邩ǂ
    private static boolean CONNECT_PLOTS = false;
    //  vbg̐F
    private static Color PLOT_COLOR = Color.blue;
    //  ̐F
    private static Color AXES_COLOR = Color.black;
    //  Obh\邩ǂ
    private static boolean SHOW_GRID = false;
    //  Obh̐F
    private static Color GRID_COLOR = Color.lightGray;
    //  Obh̊Ԋu̍Œ̒l(sNZP)
    private static int MIN_GRIDSIZE = 20;
    //  ItXN[obt@
    private static Image OS_BUF;

    private static class AxisMetrics {
        int nSIZE; double dMIN, dMAX, dSIZE;
        int nUNIT; double dUNIT;
        int nLOWEST; double dLOWEST;
        int nORIGIN; double dORIGIN;
        AxisMetrics(int nsize, double[] range) {
            checkRange(range);
            nSIZE = nsize;
            dMIN = range[0]; dMAX = range[1]; dSIZE = dMAX - dMIN;
            calcUnit();
            nUNIT = (int)(nSIZE * dUNIT / dSIZE);
            if (dMIN > 0) dLOWEST = ((int)(dMIN / dUNIT) + 1) * dUNIT;
            else if (dMIN < 0) dLOWEST = ((int)(dMIN / dUNIT)) * dUNIT;
            else dLOWEST = 0.0;
            nLOWEST = (int)((dLOWEST - dMIN) * nSIZE / dSIZE);
            dORIGIN = dLOWEST;  nORIGIN = nLOWEST;
            if (dLOWEST < 0 && dMAX > 0) {
                //  ͈͂ 0 ܂ޏꍇ_I 0 ɂ
                while ((int)(nSIZE * (dORIGIN + dUNIT) / dSIZE) <= 0) {
                    dORIGIN += dUNIT;  nORIGIN += nUNIT;
                }
            }
        }
        private void calcUnit() {
            //  `̈悪
            if (nSIZE <= MIN_GRIDSIZE) throw new IllegalArgumentException();
            dUNIT = 1.0;  // ftHg̑傫=1.0
            nUNIT = (int)(nSIZE / dSIZE);
            while (nUNIT >= nSIZE) {  // `̈傫ꍇ
                //  Obh̊Ԋu 1/10 ݂ŕύX
                dUNIT /= 10; nUNIT = (int)(nSIZE * dUNIT / dSIZE);
            }
            //  KȒlȂ(`̈悪)
            if (nUNIT == 0) throw new IllegalArgumentException();
            //  Œᕝ(=MIN_GRIDSIZE)Ȃ
            while (nUNIT <= MIN_GRIDSIZE) {
                //  2 {
                dUNIT *= 2;
                nUNIT = (int)(nSIZE * dUNIT / dSIZE);
                if (nUNIT > MIN_GRIDSIZE) break;
                //  5 {
                dUNIT = ((dUNIT / 2) * 5);
                nUNIT = (int)(nSIZE * dUNIT / dSIZE);
                if (nUNIT > MIN_GRIDSIZE) break;
                //  10 {
                dUNIT *= 2;
                nUNIT = (int)(nSIZE * dUNIT / dSIZE);
            }
            //  KȒlȂ(`̈悪)
            if (nUNIT >= nSIZE) throw new IllegalArgumentException();
        }
        //  l͈͎̔w̃`FbN郁\bh
        private static void checkRange(double[] range) {
            if (range == null || range[0] >= range[1])
                throw new IllegalArgumentException();
        }
    }
    private static AxisMetrics xmetrics = null, ymetrics = null;

    //  `͈̔͂ݒ肷郁\bh
    protected static void setXRange(int max, double[] range) {
        xmetrics = new AxisMetrics(max, range);
    }
    protected static void setYRange(int max, double[] range) {
        ymetrics = new AxisMetrics(max, range);
    }

    //  "min:max" `̕񂩂琔l͈̔͂\z𓾂郁\bh
    private static double[] parseRange(String param) {
        StringTokenizer token = new StringTokenizer(param,":");
        if (!token.hasMoreTokens()) return null;
        double min = Double.valueOf(token.nextToken()).doubleValue();
        if (!token.hasMoreTokens()) return null;
        double max = Double.valueOf(token.nextToken()).doubleValue();
        return new double[] {min, max};
    }

    //  EObh`悷郁\bh
    private static void drawAxes(Graphics g) {
        int nyorig = ymetrics.nSIZE - ymetrics.nORIGIN;
        double dlabel = xmetrics.dLOWEST;
        //  draw horizontal axis' labels
        g.setColor(AXES_COLOR);
        for (int pos = xmetrics.nLOWEST;
             pos <= xmetrics.nSIZE;
             pos += xmetrics.nUNIT) {
            if (SHOW_GRID) {
                g.setColor(GRID_COLOR);
                g.drawLine(pos, 0, pos, ymetrics.nSIZE);
                g.setColor(AXES_COLOR);
            }
            g.drawLine(pos, nyorig - 4, pos, nyorig + 4);
            g.drawString(Double.toString(dlabel), pos + 2, nyorig - 8);
            dlabel += xmetrics.dUNIT;
        }
        dlabel = ymetrics.dLOWEST;
        //  draw vertical axis' labels
        for (int pos = ymetrics.nSIZE - ymetrics.nLOWEST;
             pos >= 0;
             pos -= ymetrics.nUNIT) {
            if (SHOW_GRID) {
                g.setColor(GRID_COLOR);
                g.drawLine(0, pos, xmetrics.nSIZE, pos);
                g.setColor(AXES_COLOR);
            }
            g.drawLine(xmetrics.nORIGIN - 4, pos,
                       xmetrics.nORIGIN + 4, pos);
            g.drawString(Double.toString(dlabel),
                         xmetrics.nORIGIN + 8, pos - 4);
            dlabel += ymetrics.dUNIT;
        }
        g.drawLine(0, nyorig, xmetrics.nSIZE, nyorig);
        g.drawLine(xmetrics.nORIGIN, 0, xmetrics.nORIGIN, ymetrics.nSIZE);
    }

    private void drawGraph(Graphics g) {
        g.drawString(getName(), 5, 12);
        g.setColor(PLOT_COLOR);
        int[] prev_pos = null;
        for (int xpos = 0; xpos <= xmetrics.nSIZE; xpos++) {
            double  x = xmetrics.dMIN
                      + xpos * xmetrics.dSIZE / xmetrics.nSIZE,
                    y = getValue(x);
            if (Double.isNaN(y)) continue;
            int ypos = ymetrics.nSIZE
                     - (int)(ymetrics.nSIZE
                             * (y-ymetrics.dMIN) / ymetrics.dSIZE);
            if (CONNECT_PLOTS) {
                if (prev_pos != null) {
                    if ((ypos >= 0 && ypos <= ymetrics.nSIZE) ||
                        (prev_pos[1] >= 0 && prev_pos[1] <= ymetrics.nSIZE))
                        g.drawLine(xpos, ypos, prev_pos[0], prev_pos[1]);
                    prev_pos[0] = xpos; prev_pos[1] = ypos;
                } else {
                    prev_pos = new int[] {xpos, ypos};
                }
            } else {
                if (ypos >=0 && ypos <= ymetrics.nSIZE)
                    g.drawLine(xpos, ypos, xpos, ypos);
            }
        }
    }

    //  Avbg̏\bh
    public void init() {
        Dimension d = getSize();
        setSize(d.width,d.height);
        setXRange(d.width,  parseRange(getParameter("xrange")));
        setYRange(d.height, parseRange(getParameter("yrange")));
        setBackground(Color.white);
        setFont(new Font("Monospaced",Font.PLAIN,12));
        CONNECT_PLOTS = (getParameter("connect_plots") != null);
        SHOW_GRID = (getParameter("show_grid") != null);

        //  ItXN[obt@̐
        OS_BUF = this.createImage(d.width, d.height);

        //  ItXN[obt@ւ̕`
        Graphics g = OS_BUF.getGraphics();
        //  EObh̕`
        drawAxes(g);
        //  Ot̕`
        drawGraph(g);
    }

    //  Avbg̕`惁\bh
    public void paint(Graphics g) {
        //  ItXN[obt@̓eʂɕ`
        g.drawImage(OS_BUF, 0, 0, null);
    }

    //  ֐̖O擾鉼zꃁ\bh
    abstract public String getName();
    //  ֐l擾鉼zꃁ\bh
    abstract public double getValue(double x);
}

