/*
* GaussJordan.java -- Gauss (KEX)--Jordan (W_) @
* @version $Revision: 1.4 $, $Date: 2003/03/13 14:24:32 $
* class RMatrix, RVector gB
*/
import java.io.*;

/**
* Aꎟ Gauss-Jordan @ŉ܂B
*@see RMatrix
*@see RVector
*@see NumberFormatter
*/

public class GaussJordan {
    /**
    * Aꎟ Gauss-Jordan @ŉ܂B
    *@param a <code>a<sub>ij</sub> = a[i-1][j-1], b<sub>j</sub> = a[j-1][n]<br></code>
    * x<sub>j</sub>  <code>a[j-1][n]</code> ɏ㏑܂B
    */
    public static void solve(double[][] a) {
        int n = a.length; // n=a[][]̍sCȂ킿m̐

        for (int k = 0; k < n; k++) {
            for (int j = k + 1; j <= n; j++) a[k][j] /= a[k][k];
            for (int i = 0; i < n; i++)
                if (i != k)
                    for (int j = k + 1; j <= n; j++)
                        a[i][j] -= a[i][k] * a[k][j];
        }
    }

    /**
    * vOłB
    *n = ƕĂ܂疢m̌͂ĂB<br>
    *<b>&quot;, Ƃ̗ӂ̍&quot;</b>\܂B
    */
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        NumberFormatter fmt7f = new NumberFormatter("13.7f"),
                        fmt7e = new NumberFormatter("18.7e"),
                        fmt3d = new NumberFormatter("3d");
        System.out.print("n = ");
        int n = Integer.parseInt(in.readLine());
        double[][] a = new double [n][n + 1],
                   b = new double [n][n + 1];

        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                a[i][j] = b[i][j] = Math.random() - Math.random();
        for (int i = 0; i < n; i++)
            a[i][n] = b[i][n] = Math.random() - Math.random();
        System.out.println("Ws (Eӂ܂)");
        RMatrix.print(a, 10, "7.3f");
        solve(a);
        System.out.println(", Ƃ̗ӂ̍");
        for (int i = 0; i < n; i++) {
            double s = b[i][n];
            for (int j = 0; j < n; j++) s -= b[i][j] * a[j][n];
            System.out.println(fmt3d.toString(i) + ": " + fmt7f.toString(a[i][n]) + " "
                + fmt7e.toString(s));
        }
    }
}
