/*
* GaussSeidel.java -- Gauss (KEX)--Seidel (UCf) @
* @version $Revision: 1.6 $, $Date: 2003/03/13 14:24:32 $
* class RVector gB
*/
import java.io.*;

/**
* Aꎟ Gauss-Seidel @ŉ܂B
*@see RMatrix
*@see NumberFormatter
*@see RVector
*@see GaussElimination
*@see Gauss3
*@see Gauss5
*/

public class GaussSeidel {
    /**
    *ro߂o͂ȂȂ false ɂ܂B
    */
    public static boolean verbose = true;
    static final double  EPS      = 1E-6; // e덷
    static final int     MAX_ITER = 500;  // őJԂ
    /**
    * Aꎟ Ax = b  Gauss-Seidel @ŉ܂B
    *@param a sA
    *@param b Eb
    *@param x C0ɏĂ܂B
    *@return  <code>true</code>C <code>false</code>
    */
    public static boolean solve(double[][] a, double[] x, double[] b) {
        int n = b.length;

        for (int iter = 1; iter <= MAX_ITER; iter++) {
            boolean ok = true;
            for (int i = 0; i < n; i++) {
                double s = b[i];
                for (int j = 0    ; j < i; j++) s -= a[i][j] * x[j];
                for (int j = i + 1; j < n; j++) s -= a[i][j] * x[j];
                s /= a[i][i];  // 炩ߑΊp1ɂĂΕsv
                if (ok && Math.abs(x[i] - s) > EPS * (1 + Math.abs(s)))
                    ok = false;
                x[i] = s;  // SOR@ȂႦ x[i] += 1.2 * (s - x[i]);
            }
            if (verbose) {
                System.out.println(iter + ":");
                RVector.print(x, 7, "11.6f");
            }
            if (ok) return true;  // 
        }
        return false;  // 
    }

    /**
    * vOłB
    *<b>&quot;n = &quot;</b>ƕĂ܂ 2 ȏ̐l͂ĂB<br>
    *ro߂\CŌɕ\ׂ͂ 1.0 ɂȂ܂B
    */

    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("n = ");
        int n = Integer.parseInt(in.readLine());
        double[][] a = new double[n][n];
        double[] x = new double[n], b = new double[n];

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) a[i][j] = 1;
            a[i][i] = 2;  b[i] = n + 1;  x[i] = 0;
        }
        if (solve(a, x, b) == false) System.out.println("܂");
        System.out.println(" (ׂ͂ 1)");
        RVector.print(x, 7, "11.6f");
    }
}
