/**
 *  Hilbert.java -- Hilbert (qxg) Ȑ
 *  (DrawOneByOnePanel.java, Plotter.java g)
 *
 *  @version $Revision: 1.7 $, $Date: 2003/03/18 10:05:53 $
 */

import java.awt.*;

public class Hilbert extends DrawOneByOnePanel {
    static final int WIDTH = 400,  HEIGHT = WIDTH;
    private int order;  // ʐ
    private double h;  // ݕ
    private Plotter pt;

    public Hilbert(int order) {
        super(WIDTH + 1, HEIGHT + 1, 2);  this.order = order;
    }

    public int getOrder() {  return order;  }

    private void rightUpLeft(int i) {
        if (i == 0) {
            sleep(500 / order / order);  // \đ҂
            return;
        }
        upRightDown(i - 1);  pt.drawRelative( h, 0);
        rightUpLeft(i - 1);  pt.drawRelative( 0, h);
        rightUpLeft(i - 1);  pt.drawRelative(-h, 0);
        downLeftUp(i - 1);
    }

    private void downLeftUp(int i) {
        if (i == 0) return;
        leftDownRight(i - 1);  pt.drawRelative( 0, -h);
        downLeftUp(i - 1);     pt.drawRelative(-h,  0);
        downLeftUp(i - 1);     pt.drawRelative( 0,  h);
        rightUpLeft(i - 1);
    }

    private void leftDownRight(int i) {
        if (i == 0) return;
        downLeftUp(i - 1);     pt.drawRelative(-h,  0);
        leftDownRight(i - 1);  pt.drawRelative( 0, -h);
        leftDownRight(i - 1);  pt.drawRelative( h,  0);
        upRightDown(i - 1);
    }

    private void upRightDown(int i) {
        if (i == 0) return;
        rightUpLeft(i - 1);    pt.drawRelative( 0,  h);
        upRightDown(i - 1);    pt.drawRelative( h,  0);
        upRightDown(i - 1);    pt.drawRelative( 0, -h);
        leftDownRight(i - 1);
    }

    synchronized public void drawSlowly(Graphics2D g) {
        g.translate(0, HEIGHT);  g.scale(1, -1);  // 1ی
        h = 1;  for (int i = 2; i <= order; i++) h = h / (2 + h);
        h *= WIDTH;  // g
        pt = new Plotter(g);  pt.moveTo(0, 0);  rightUpLeft(order);
    }

    public static void main(String[] args) {
        Hilbert p = new Hilbert(5);
        p.makeFrame("qxgȐiʐ = " + p.getOrder() + "j");
    }
}
