/*
* Horner.java -- Horner (z[i[) @
* @version $Revision: 1.1 $, $Date: 2003/01/07 00:34:06 $
*/

/**
* Horner (z[i[) @gđ̒l<code><br>
* <i>f</i>(<i>x</i>) = <i>a<sub>n-1</sub> x <sup>n-1</sup></i> +
*<i>a<sub>n-2</sub> x <sup>n-2</sup></i> +...+ <i>a</i><sub>0</sub><i>x</i><sup>0</sup>
*<br></code>
* vZ܂B
*/

public class Horner {
    /**
    * @param a W<code><i>a</i><sub>0</sub>,...,<i>a<sub>n-2</sub>,a<sub>n-1</sub></i>
    *</code> <i>n</i> ̐l^܂B
    *C<code><i>n</i> = a.lenght, a[0] = <i>a</i><sub>0</sub></code>Ƃ܂B
    *@param x <code><i>x </i></code>̐l^܂B
    *@return 
    * <code><i>a<sub>n-1</sub> x <sup>n-1</sup></i> +
    *<i>a<sub>n-2</sub> x <sup>n-2</sup></i> +...+ <i>a</i><sub>0</sub><i>x</i><sup>0</sup>
    *</code>
    * ̐lԂ܂B
    */
    public static double getValue(double a[], double x) {
        int n = a.length;
        double p = a[n - 1];

        for (int i = n - 2; i >= 0; i--) p = p * x + a[i];
        return p;
    }
    /**
    * eXgpvOłB
    */
    public static void main(String[] args) {
        double a[] = { 1, 2, 3, 4, 5 }, x = 10;

        System.out.println("f(" + x + ") = " + getValue(a, x));
    }
}
