/*
* Householder.java -- Householder (nEXz_[) ϊ
* @version $Revision: 1.3 $, $Date: 2003/03/13 14:24:32 $
*/
import java.io.*;
import java.util.Random;

/**
* Householder (nEXz_[) ϊ̃vOłB
*@see Tridiagonalize
*@see RVector
*/

public class Householder {
    /**
    * Householder ϊ̃vOłB
    *@param x ϊxNg
    *@return ϊ̃xNg̍ŏ̐
    */
    public static double transform(double[] x) {
        double s = Math.sqrt(RVector.innerProduct(x, x));  /* ς̕, Ȃ킿xNg $x$ ̑傫 */

        if (s != 0) {
            if (x[0] < 0) s = -s;
            x[0] += s;  double t = 1 / Math.sqrt(x[0] * s);
            for (int i = 0; i < x.length; i++) x[i] *= t;
        }
        return -s;
    }

    /**
    * gvOłB<br>
    *<b>&quot;n = &quot;</b>ƕĂ܂ 2 ȏ̐l͂ĂB<br>
    *ϊOƕϊ̃xNg( 1 ȊO 0)ѓ敽ό덷o͂܂B
    */

    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("n = ");
        int n = Integer.parseInt(in.readLine());
        double[] x = new double[n], v = new double[n];
        double s = 0;

        for (int i = 0; i < n; i++) {
            x[i] = v[i] = Math.random() - Math.random();
            s += x[i] * x[i];
        }
        System.out.println("x:");
        RVector.print(x, 7, "10.6f");
        System.out.println("||x|| = " + Math.sqrt(s));

        double x1 = transform(v);  /* Householderϊ */
        System.out.println("x' = (" + x1 + ", 0, ..., 0)");  /* ϊ̃xNgo */
        s = 0;  /* ȉ͊mF */
        for (int i = 0; i < n; i++) s += v[i] * x[i];
        for (int i = 0; i < n; i++) x[i] -= s * v[i];
        s = (x[0] - x1) * (x[0] - x1);
        for (int i = 1; i < n; i++) s += x[i] * x[i];
        System.out.println("敽ό덷: " + Math.sqrt(s / n));
    }
}
