/**
* KMP.java -- Knuth--Morris--Pratt@
* @version $Revision: 1.3 $, $Date: 2002/12/16 01:03:25 $
*/

/**
*Knuth, Morris and Pratt ɂ镶ƍASỸvOłB
*/

public class KMP {
    /**
    *text ̒ pattern ̂ʒuT܂B
    *@param text 
    *@param pattern T
    *@return pattern ̂ʒuB擪 0B
    *pattern ꍇ〈Ȃꍇ -1 C
    *pattern ̒ 0 ̏ꍇ 0 Ԃ܂B
    */
    public static int position(String text, String pattern) {
        int tLen = text.length(), pLen = pattern.length();
        if (pLen > tLen) return -1;  /* G[: {\tt pattern} */
        if (pLen == 0) return 0;
        int[] next = new int[pLen + 1];

        int i = 1, j = 0;  // next[1] = 0;
        while (i <  pLen) {
            if (pattern.charAt(i) == pattern.charAt(j)) {
                i++;  j++;  next[i] = j;
            } else if (j == 0) { i++;  next[i] = j; }
            else j = next[j];
        }
        /* fXg[Vp */
        for (int k = 0; k < pLen; k++)
            System.out.println("pattern[" + k + "] = " + pattern.charAt(k)
                    + ", next[" + (k+1) + "] = " + next[k+1]);
        /**************************/
        i = j = 0;
        while (i < tLen && j < pLen) {
            if (text.charAt(i) == pattern.charAt(j)) {  i++;  j++;  }
            else if (j == 0) i++;
            else j = next[j];
        }
        if (j == pLen) return i - j;
        return -1;  /* Ȃ */
    }
    /**
    * text = <b>&quot;supercalifragilisticexpialidocious&quot;</b>,
    * pattern = <b>&quot;ilisti&quot;</b> ̏ꍇ
    *vOłB
    *ro߂\܂B
    */

    public static void main(String[] args) {
        String text = "supercalifragilisticexpialidocious", pattern = "ilisti";
//      String text = "ABCABCABABC", pattern = "ABCABA";

        System.out.println("position(\"" + text + "\"" + ", \"" + pattern + "\") = " + position(text, pattern));
    }
}
