/**
 *  LU yтgA[`
 *
 *  @version $Revision: 1.5 $, $Date: 2003/03/13 14:24:33 $
 */
public class LU {
    private LU() {}
    /**
     *  s a  LU B<br>
     *  s{bgIsCۂɍŝł͂ȂC
     *  s̔ԍC̏𐮐̔z ivec ɓĖ߂B
     *   ivec ͌o solve() gĎۂɘAۂ
     *  KvɂȂ̂łB
     *
     *  @param  a   LU s(̌ʂŏ㏑)
     *  @param  ivec    ši[z
     *  @return a ̍s񎮁Bꂪ 0 Ȃ LU łȂƂӖB
     *  @see    #solve
     */
    public static double lu(double[][] a, int[] ivec) {
        int n = a.length;
        double[] weight = new double[n];
        for (int k = 0; k < n; k++) {   //  esɂ
            ivec[k] = k;    //  s̏l
            double u = 0;   //  ̍s̐Βlő̗vf߂
            for (int j = 0; j < n; j++) {
                double t = Math.abs(a[k][j]); if (t > u) u = t;
            }
            if (u == 0) return 0;   //  0 Ȃs LU łȂ
            weight[k] = 1 / u;      //  őΒl̋t
        }
        double det = 1;     //  s񎮂̏l
        for (int k = 0, m = n; k < n; k++) {    //  esɂ
            double u = -1;
            for (int i = k; i < n; i++) {   //  艺̊esɂ
                int ii = ivec[i];   //  d݁~Βl ő̍s
                double t = Math.abs(a[ii][k]) * weight[ii];
                if (t > u) { u = t; m = i; }
            }
            int ik = ivec[m];
            if (m != k) {
                ivec[m] = ivec[k]; ivec[k] = ik;    //  sԍ
                det = -det;     //  s΍s񎮂̕ς
            }
            u = a[ik][k]; det *= u;  //  Ίp
            if (u == 0) return 0;   //  0 Ȃs LU łȂ
            for (int i = k + 1; i < n; i++) {   //  Gauss @
                int ii = ivec[i];
                a[ii][k] /= u;
                double t = a[ii][k];
                for (int j = k + 1; j < n; j++)
                    a[ii][j] -= t * a[ik][j];
            }
        }
        return det;     //  ߂l͍s
    }
    /**
     *  lu()  LU s a gĘAP a x = b B
     *
     *  @param  a   LU ς݂̍s
     *  @param  b   ẢE
     *  @param  ivec    š񂪊i[ꂽz
     *  @param  x   i[xNg
     *  @see    #lu
     */
    public static void solve(double[][] a, double[] b,
                             int[] ivec, double[] x) {
        int n = a.length;
        for (int i = 0; i < n; i++) {
            int ii = ivec[i]; double t = b[ii];
            for (int j = 0; j < i; j++) t -= a[ii][j] * x[j];
            x[i] = t;
        }
        for (int i = n - 1; i >= 0; i--) {
            double t = x[i]; int ii = ivec[i];
            for (int j = i + 1; j < n; j++) t -= a[ii][j] * x[j];
            x[i] = t / a[ii][i];
        }
    }
    /**
     *  lu(), solve() ɌĂяoĘA a x = b B<br>
     *  APgȂ炱g΂悢CgȂ
     *  ŏɂP񂾂 lu() ĂяoCƂ solve() KvȂ
     *  ĂяoB
     *
     *  @param  a   ǍWs
     *  @param  b   ẢE
     *  @param  x   i[xNg
     *  @return a ̍s񎮁Bꂪ 0 ȂA͕s(܂Ȃ)
     *          ܂͕s\(݂Ȃ)B
     *  @see    #lu
     *  @see    #solve
     */
    public static double gauss(double[][] a, double[] b, double[] x) {
        int n = a.length; int[] ivec = new int[n];
        double det = lu(a, ivec);
        if (det != 0) solve(a, b, ivec, x);
        return det;
    }
}

