/*
* LUDecomposition.java -- LU
* @version $Revision: 1.7 $, $Date: 2003/03/13 14:24:33 $
* main()  class RMatrix, RVector, NumberFormatter gB
* mathutils.LU.java; ƂقړB
*/
import java.io.*;

/**
*LUŘAP܂B
*@see RMatrix
*@see RVector
*@see NumberFormatter
*/
public class LUDecomposition {
    static double lu(double[][] a, int[] ip) {
        int n = a.length;
        double[] weight = new double[n];    // weight[0..n-1] ̋L̈m

        for (int k = 0; k < n; k++) {   // esɂ
            ip[k] = k;                  // s̏l
            double u = 0;               // ̍s̐Βlő̗vf߂
            for (int j = 0; j < n; j++) {
                double t = Math.abs(a[k][j]);  if (t > u) u = t;
            }
            if (u == 0) return 0;   // 0 ȂsLUłȂ
            weight[k] = 1 / u;      // őΒl̋t
        }
        double det = 1;                 // s񎮂̏l
        for (int k = 0; k < n; k++) {   // esɂ
            double u = -1;
            int m = 0;
            for (int i = k; i < n; i++) {// 艺̊esɂ
                int ii = ip[i];          // d݁~Βl ő̍s
                double t = Math.abs(a[ii][k]) * weight[ii];
                if (t > u) {  u = t;  m = i;  } //  u = -1 && t >= 0 ł邩{}͕KsB
            }
            int ik = ip[m];
            if (m != k) {
                ip[m] = ip[k];  ip[k] = ik; // sԍ
                det = -det;  // s΍s񎮂̕ς
            }
            u = a[ik][k];  det *= u;    // Ίp
            if (u == 0) return 0;       // 0 ȂsLUłȂ
            for (int i = k + 1; i < n; i++) {// Gauss@
                int ii = ip[i];  double t = (a[ii][k] /= u);
                for (int j = k + 1; j < n; j++) a[ii][j] -= t * a[ik][j];
            }
        }
        return det;           // ߂l͍s
    }
    /**
    *LǓʂgĘAP Ax = b ܂B
    *EӂقȂ镡̘AP̂ɕ֗łB
    *@param a LUWs
    *@param b E
    *@param x 
    *@param ip <code>lu()</code>̍s
    */

    public static void solve(double[][] a, double[] b, int[] ip, double[] x) {
        int n = a.length;

        for (int i = 0; i < n; i++) {   // Gauss@̎c
            int ii = ip[i];  double t = b[ii];
            for (int j = 0; j < i; j++) t -= a[ii][j] * x[j];
            x[i] = t;
        }
        for (int i = n - 1; i >= 0; i--) { // ޑ
            double t = x[i];  int ii = ip[i];
            for (int j = i + 1; j < n; j++) t -= a[ii][j] * x[j];
            x[i] = t / a[ii][i];
        }
    }
    /**
    *LǓʂgĘAP܂B
    *@param a Ws
    *@param b E
    *@param x 
    *@return s
    */
    public static double gauss(double[][] a, double[] b, double[] x) {
        int   n    = a.length;
        int[] ip   = new int[n]; // s̏
        double det = lu(a, ip);  // LUčs񎮂󂯎

        if (det != 0) solve(a, b, ip, x);  // LǓʂgĘA
        return det;                        // ߂l͍s
    }

    /**
    * gvOłB<br>
    *<strong>&quot;s̎ n = &quot;</strong>ƕĂ܂2ȏ
    *l͂ĂB<br>
    *s񎮂̒lщ, Ƃ̗ӂ̍o͂܂B
    */
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("s̎ n = ");
        int n = Integer.parseInt(in.readLine());    // s̎
        double[][] a = new double[n][n], aSave = new double[n][n];
        double[]   b = new double[n],    bSave = new double[n],
                   x = new double[n];

        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                a[i][j] = aSave[i][j] = Math.random() - Math.random();

        System.out.println("Ws");
        RMatrix.print(a, 10, "7.3f");
        for (int i = 0; i < n; i++)
            b[i] = bSave[i] = Math.random() - Math.random();
        System.out.println("E");
        RVector.print(b, 10, "7.3f");

        double det = gauss(a, b, x);  // Gauss@ $Ax=b$ 
        System.out.println("s = " + det);
        System.out.println(", Ƃ̗ӂ̍");

        NumberFormatter fmtf = new NumberFormatter("16.7f"),
                        fmte = new NumberFormatter("16.7e"),
                        fmtd = new NumberFormatter("2d");
        for (int i = 0; i < n; i++) {
            double s = bSave[i];
            for (int j = 0; j < n; j++) s -= aSave[i][j] * x[j];
            System.out.println(fmtd.toString(i) + ":" + fmtf.toString(x[i]) +
                fmte.toString(s));
        }
    }
}
