/*
* LogE.java
* log(x) ߂B
* @version $Revision: 1.9 $, $Date: 2003/02/26 15:30:26 $
* v Exp, LogNX (Exp.ldexp(x,k) = 2^k x ߂邽߂ɗp)
*/
/**
* Rΐ log(x) ߂܂B
* @see Exp
* @see Log
*/
public class LogE {
    private static double
        LOG2  = 0.693147180559945309417232121458; // log_e 2
    private static double
        SQRT2 = 1.41421356237309504880168872421; // sqrt(2)
/**
* P <code>log x = r + log(1 - x') (x' = 1 - x * e<sup>-r</sup>)</code> 
* glog(x) ߂܂B
* @param x 
* @return log(x)
*/
    public static double log_exp(double x) { // Rΐiexp(x)gpŁj
        if (x <= 0) return Double.NaN;
        Log.Frexp frexp = new Log.Frexp(x / SQRT2);
        x = Exp.ldexp(x, -frexp.k); // sqrt(0.5) < x < sqrt(2)

        double r = 2 * (x - 1) / (x + 1);    // log(x) ̋ߎl 덷1%ȉ
        double xp = 1.0 - x * Math.exp(-r); // |xp| << 1.0, exp(-r)͍ɋ܂

        // log(1 - xp) ߂B
        double u = xp / (xp - 2), d = u, u2 = u * u, s = u, last;
        int i = 1;
        do{ // ̃[v͐ŏIB
            d *= u2;  i += 2;  last = s;  s += d / i;
        } while (last != s);
        return LOG2 * frexp.k + r + 2 * s;  // 2 * s = log(1 - xp)
    }
/**
* eXgvOłB<br>
* log(x) ̌vZx̔r܂B
*/
    public static void main(String[] args){
        final int N = 500000;
        double x, y = 0.0, y_cf = 0.0, y_exp = 0.0, y_log = 0.0;

        do { x = Math.random() * 10; } while( x == 0.0);
        System.out.println("log(" + x + ") ̒l " + N + " Zđxƌʂr\n");

        long start = System.currentTimeMillis();
        for(int i = 0; i < N; i++) y += Math.log(x);
        long time = System.currentTimeMillis() - start;
        System.out.println("CPU time of Math.log(x) " + time + "(ms)");

        start = System.currentTimeMillis();
        for(int i = 0; i < N; i++) y_cf += Log.log_cf(x);
        time = System.currentTimeMillis() - start;
        System.out.println("CPU time of Log.log_cf(x) " + time + "(ms)");

        start = System.currentTimeMillis();
        for(int i = 0; i < N; i++) y_exp += LogE.log_exp(x);
        time = System.currentTimeMillis() - start;
        System.out.println("CPU time of Log.log_exp(x) " + time + "(ms)");

        start = System.currentTimeMillis();
        for(int i = 0; i < N; i++) y_log += Log.log(x);
        time =  System.currentTimeMillis() - start;
        System.out.println("CPU time of Log.log(x) " + time + "(ms)");

        System.out.println("Math.log(x) = " + y);
        System.out.println("log_cf(x) = " + y_cf);
        System.out.println("log_exp(x) = " + y_exp);
        System.out.println("error =" + (y - y_exp));
    }

}
