/**
 *  fLucaseXg BigInteger 
 *
 *  $Revision: 1.8 $, $Date: 2003/04/28 23:23:17 $
 */

import java.math.*;

public class Lucas1 {
    static final BigInteger ONE  = BigInteger.valueOf(1);
    static final BigInteger TWO  = BigInteger.valueOf(2);
    static final BigInteger FOUR = BigInteger.valueOf(4);

    /** 2^p-1 fȂ true Ԃ (p3ȏ̑f) */
    public static boolean isMersennePrime(int p) {
        BigInteger m = TWO.pow(p).subtract(ONE);
        BigInteger x = FOUR;
        for (int i = 2; i < p; i++) {
            System.err.print((p - i) + " \r");  // {͍폜({})
            x = x.pow(2).subtract(TWO).mod(m);
        }
        return (x.signum() == 0);  // signum() ͕ɉ +1,0,-1 Ԃ
    }

    public static void main(String[] args) {
        if (args.length != 1) {
            System.out.println("gp@: java Lucas1 p");
            return;
        }
        final int p = Integer.parseInt(args[0]);
        if (p < 3) {
            System.out.println("Rȏ̑fw肵ĉ");
            return;
        }
        System.out.println("2^" + p + "-1  ...");
        if (isMersennePrime(p)) System.out.println("fł");
        else                    System.out.println("ł");
    }
}
