/**
* MatMult.java -- s̐
* @version $Revision: 1.4 $, $Date: 2003/03/13 14:24:33 $
*/

/**
* s̐ςvZ܂B
* @see RMatrix
* @see OptMult
* @see UTMult
*/
public class MatMult {
    /**
    * s̐ c(n~m) = a(n~l)~b(l~m) vZ܂B<br>
    * ŁCx(Y~Z)YsZ̍sxӖ܂B<br>
    * a̗񐔂b̍sƈقȂꍇɂ̓G[I܂B
    * @param c ab܂B
    * @param a s a
    * @param b s b
    */
    public static void getOnC(double[][] c, double[][] a, double[][] b) {
        // a[n][l] ̂ƂCa.length = n, a[0].length = l ɂȂB
        int n = a.length, l = a[0].length, m = b[0].length;

        if (l != b.length) throw new Error("ςvZł܂");
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++) {
                double s = 0;
                for (int k = 0; k < l; k++) s += a[i][k] * b[k][j];
                c[i][j] = s;
            }
    }
    /**
    * s̐ a(n~n) = a(n~n) x b(n~n) vZ܂B<br>
    * a܂bsłȂꍇ̓G[I܂B
    * @param a s aCab㏑܂B
    * @param b s b
    */
    public static void getOnA(double[][] a, double[][] b) {
        int n = a.length;

        if (n != a[0].length || n != b.length
                || n != b[0].length) throw new Error("ςvZł܂");
        double[] temp = new double[n];

        for (int i = 0; i < n; i++) {
            for (int k = 0; k < n; k++) temp[k] = a[i][k];
            for (int j = 0; j < n; j++) {
                double s = 0;
                for (int k = 0; k < n; k++) s += temp[k] * b[k][j];
                a[i][j] = s;
            }
        }
    }
    /**
    * gvOłB
    */

// eXgp : mathutils.RMatrix.java gpB
    public static void main(String[] args) {
        final int N = 3, L = 5, M = 4;
        String fmt = new String("8.1f");
        int i, j;
        double[][] a = new double[N][L];
        double[][] b = new double[L][M];
        double[][] c = new double[N][M];

        for (i = 0; i < N; i++)
            for (j = 0; j < L; j++)
                a[i][j] = 10 * Math.random();
        for (i = 0; i < L; i++)
            for (j = 0; j < M; j++)
                b[i][j] = 10 * Math.random();
        System.out.println("A");  RMatrix.print(a, L, fmt);
        System.out.println("B");  RMatrix.print(b, M, fmt);
        getOnC(c, a, b);
        System.out.println("AB"); RMatrix.print(c, M, fmt);

        double[][] d = new double[N][N];
        double[][] e = new double[N][N];
        double[][] f = new double[N][N];

        for (i = 0; i < N; i++)
            for (j = 0; j < N; j++) {
                d[i][j] = 10 * Math.random();
                e[i][j] = 10 * Math.random();
            }
        System.out.println("D");  RMatrix.print(d, N, fmt);
        System.out.println("E");  RMatrix.print(e, N, fmt);
        getOnC(f, d, e);
        getOnA(d, e);
        System.out.println("DE by getOnC()");  RMatrix.print(f, N, fmt);
        System.out.println("DE by getOnA()");  RMatrix.print(d, N, fmt);
    }
}
