/**
 *  MultiPrecision.java -- {Z
 *
 * @version $Revision: 1.1 $, $Date: 2003/03/20 11:31:06 $
 */

import java.util.Arrays;
import java.math.*;
import java.io.*;

/**
*{Z̃vOłB
*/
public class MultiPrecision {
    /**
    *̃rbgłB30 ɂƂĂ܂B
    */
    public  static final int RADIXBITS = 30; // ̃rbg
    /**
    *łB2<sup>30</sup> = 1,073,741,824 ɂƂĂ܂B
    */
    public  static final int RADIX = (1 << RADIXBITS); //  1073741824
    private static int n;              // RADIX i@ŏ n ʂ܂
    /**
    *RXgN^
    *@param n RADIX i@̌
    */
    public MultiPrecision(int n) {    // RXgN^in  RADIX i@̌j
        this.n = n;
    }
    /**
    *a c = a + b vZ܂B
    */
    public static void add(int[] a, int[] b, int[] c) {
        int t = 0;
        for (int i = n; i >= 0; i--) {
            t += a[i] + b[i];
            c[i] = t & (RADIX - 1);
            t >>= RADIXBITS;
        }
        if (t != 0) throw new Error("Overflow");
    }
    /**
    * c = a - b vZ܂Ba &gt; b łȂ΂܂B
    */
    public static void sub(int[] a, int[] b, int[] c) {
        int t = 0;
        for (int i = n; i >= 0; i--) {
            t = a[i] - b[i] - t;
            c[i] = t & (RADIX - 1);
            t = (t >> RADIXBITS) & 1;
        }
        if (t != 0) throw new Error("Overflow");
    }
    /**
    *Ƃ̐ c = a * x vZ܂B
    */
    public static void muls(int[] a, int x, int[] b) {
        long t = 0;
        for (int i = n; i >= 0; i--) {
            t += (long)a[i] * x;
            b[i] = (int)t & (RADIX - 1);
            t >>= RADIXBITS;
        }
        if (t != 0) throw new Error("Overflow");
    }
    /**
    *ł̏ c = a / x vZ܂B
    *@param m a[]  0łȂōʒu
    */
    public static int divs(int m, int[] a, int x, int[] b) {// a[m..0] / x --> b
        long t = 0;
        for (int i = m; i <= n; i++) {
            t = (t << RADIXBITS) + a[i];
            b[i] = (int)(t / x);
            t = t - (long)b[i] * x; // t %= x 葬B
//          t %= x;
        }
        if (2 * t >= x)         // ľܓ
            for (int i = n; (++b[i] & RADIX) != 0; i--)
                b[i] &= RADIX - 1;
        return (b[m] != 0) ? m : (m + 1);  // 0łȂōʒu
    }
    /**
    *10i\֕̕ϊ܂B
    */
    public static String toString(int[] r) {
        int[] a = new int[r.length];
        System.arraycopy(r, 0, a, 0, r.length); // r[] ̓e󂳂Ȃ悤ɃRs[B
        StringBuffer x = new StringBuffer(a[0] + ".");

        for (int i = 0; i < n; i++) {
            a[0] = 0;
            muls(a, 1000000000, a);
            StringBuffer sb = new StringBuffer(Integer.toString(a[0]));
            x.append("000000000".substring(0, 9 - sb.length()) + sb);
        }
        return x.toString();
    }
    /**
    *BigDecimal lɕϊ܂B
    */
    public static BigDecimal toBigDecimal(int[] r) {
        return new BigDecimal(toString(r));
    }
    /**
    *10i\ŕWo͂ɏo͂܂B
    */
    public static void print(int[] r) {
        System.out.println(toString(r));
    }
    /**
    *Svf 0 ŏ܂B
    */
    public static void setZero(int[] a) {  Arrays.fill(a, 0); }

    // ȉ̓eXgp
    /**
    *Rΐ̒vZ܂B
    */
    public static int[] e() {
        int[] a = new int[n+1];
        int[] t = new int[n+1];
        a[0] = 2;  a[1] = t[1] = RADIX / 2; // a := 2.5, t := 0.5
        int k = 3, m = 1;
        while ((m = divs(m, t, k, t)) <= n) { // t := t/k
            add(a, t, a);       // a := a + t
            if (++k == RADIX) throw new Error("܂");
        }
        return a;
    }
    /**
    *~ MachiňgČvZ܂B
    */
    public static int[] pi() {
        int[] a = new int[n+1];
        int[] t = new int[n+1];
        int[] u = new int[n+1];
        t[0] = 16;              // t := 16
        divs(0, t, 5, t);       // t := t/5
        for (int i = 0; i <= n; i++) a[i] = t[i]; // a := t
        int j = 0, m = 0, k = 1;
        while (true) {
            if ((m = divs(m, t, 25, t)) > n) break; // t := t/25
            if ((k += 2) >= RADIX) throw new Error("܂");
            while (j < m) u[j++] = 0;
            if (divs(m, t, k, u) > n) break; // u := t/k
            if ((k & 2) != 0) sub(a, u, a);
            else              add(a, u, a); // a := a -+ u
        }
        t[0] = 4;               // t := 4
        divs(0, t, 239, t);     // t := t/239
        sub(a, t, a);           // a := a - t
        j = m = 0;  k = 1;
        while (true) {
            if ((m = divs(m, t, 239 * 239, t)) > n) break; // t := t/(239*239)
            if ((k += 2) >= RADIX) throw new Error("܂");
            while (j < m) u[j++] = 0;
            if (divs(m, t, k, u) > n) break; // u := t/k
            if ((k & 2) != 0) add(a, u, a);
            else              sub(a, u, a); // a := a +- u
        }
        return a;
    }
    /**
    *vOłB
    *Rΐ̒Ɖ~o͂܂B
    */
    public static void main(String[] args) {
        final int N = 100;
        long start= System.currentTimeMillis(), end;
        MultiPrecision m = new MultiPrecision(N);
        int[] e = m.e(), pi = m.pi();

        System.out.println("e = \n" + toString(e));
        System.out.println("pi = \n" + toString(pi));
        end =  System.currentTimeMillis();
        System.out.println("CPU time" + (end - start) + "(ms)");
    }
}
