/**
 * Newton1Test.java -- Newton@(Newton1)̎gp
 * @version $Revision: 1.4 $, $Date: 2003/04/05 15:10:00 $
 */

import java.io.*;
import java.util.*;

/**
 * Newton@(Newton1)̎gpłB<br>
 * ֐ <code>f(x) = x<sup>3</sup> - 2x + 3</code>C
 * ֐ <code>f'(x) = 3x<sup>2</sup> - 2</code>
 * ^Ă܂B<br>
 * @see Newton1
 */
public class Newton1Test {
    /** f(x) = x^3 + bx^2 + c^x + d */
    static class CubicFunction implements Newton1.Function {
        private double b, c, d;
        public CubicFunction(double a, double b, double c, double d) {
            this(b / a, c / a, d / a);
        }
        public CubicFunction(double b, double c, double d) {
            this.b = b;  this.c = c;  this.d = d;
        }
        public double of(double x) { // _߂֐ $f(x)$
            return ((b + x) * x + c) * x + d;
        }
        public double primeOf(double x) { // $f(x)$ ̓֐
            return (2 * b + 3 * x) * x + c;
        }
    }

    /**
     * JȏꍇāCR<br>
     * <code>x<sup>3</sup> + bx<sup>2</sup> + cx + d = 0</code><br>
     * C̎\܂B
     */
    // QlFxmFACOM}jAuSSL II gpv
    public static void solveCubicEq(double a, double b, double c, double d) {
        b /= a;  c /= a;  d /= a;
        a = b * b - 3 * c;
        CubicFunction cf = new CubicFunction(b, c, d);

        if (a > 0) {
            double minP = (-b + Math.sqrt(a))/3.0;  // ɏ_̍W
            double maxP = (-b - Math.sqrt(a))/3.0;  // ɑ_̍W
            double minF = cf.of(minP);              // ɏl
            double maxF = cf.of(maxP);              // ɑl
            a = (2.0 / 3.0) * Math.sqrt(a);
            if (minF * maxF < 0) { // 3̉ꍇ
                double x1 = Newton1.solve(cf, -a - b / 3);  // 
                System.out.println("x1 = " + x1);
                double x2 = Newton1.solve(cf, a - b / 3);   // E
                System.out.println("x2 = " + x2);
                double x3 = Newton1.solve(cf, b / (-3));    // ϋȓ_
                System.out.println("x3 = " + x3);
            } else { // 1d
                double x0;
                if (maxF > 0) x0 = -a - b / 3;  // 
                else          x0 =  a - b / 3;  // E
                double x1 = Newton1.solve(cf, x0);
                System.out.println("x1 = " + x1);
                if (minF == 0) System.out.println("x2 = " + minP + " (d)");
                if (maxF == 0) System.out.println("x2 = " + maxP + " (d)");
            }
        } else if (a < 0) { // f'(x) = 0 Ȃꍇ
            double x1 = Newton1.solve(cf, b / (-3));    // ϋȓ_
            System.out.println("x = " + x1);
        } else { // f'(x) = 0 dꍇ
            double x0 = b / (-3); // ϋȓ_
            x0 = x0 - cf.of(x0);  // @1Kp
            double x1 = Newton1.solve(cf, x0);
            System.out.println("x1 = " + x1 + " (d)");
        }
    }

    /**
     * W a, b, c, d 󔒂ŋ؂ē͂ƂR<br>
     * <code>ax<sup>3</sup> + bx<sup>2</sup> + cx + d = 0</code><br>
     * ̎\܂B
     * @see Cardano
     */
    public static void main(String[] args) throws IOException {
        System.out.println("ax^3+bx^2+cx+d=0܂.");
        System.out.println("a b c d ? ");
        BufferedReader in =
            new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer(in.readLine());
        double a = Double.parseDouble(st.nextToken()),
               b = Double.parseDouble(st.nextToken()),
               c = Double.parseDouble(st.nextToken()),
               d = Double.parseDouble(st.nextToken());
        if (a == 0) {
            System.out.println("3ł͂܂B");  System.exit(-1);
        }

        System.out.println("Cardano(J_m)̌gp");
        Cardano.solve(a, b, c, d);
        System.out.println();

        System.out.println("solveCubicEq()gp");
        solveCubicEq(a, b, c, d);
        System.out.println();

        System.out.println("Newton1 gp");
        b /= a;  c /= a;  d /= a;
        a = b * b - 3 * c;
        CubicFunction cf = new CubicFunction(b, c, d);
        if (a > 0) {
            double mp = (-b + Math.sqrt(a))/3.0;    // ɏ_̍W
            a = (2.0 / 3.0) * Math.sqrt(a);
            double x1 = Newton1.solve(cf, -a - b / 3);  // Cɏ_̒Jn邱Ƃł
            System.out.println("x1 = " + x1);
            if (cf.of(mp) > 0) System.exit(0);      // ɏl :̔肪Ȃ 2 5 2 6 ȂǂŎȂ
            double x2 = Newton1.solve(cf, a - b / 3);   // E
            if (x2 == x1) System.exit(0);
            System.out.println("x2 = " + x2);
            double x3 = Newton1.solve(cf, b / (-3));    // ϋȓ_
            System.out.println("x3 = " + x3);
        } else {
            double x1 = Newton1.solve(cf, 0);           // Kȓ_
            System.out.println("x = " + x1);
        }
    }
}
