/**
* PrinComp.java -- 听
* @version $Revision: 1.7 $, $Date: 2003/03/13 14:24:34 $
* QR.java -- QR@ gB
*/
import java.io.*;

/**
*听͂̃vOłB
*@see NumberFormatter
*@see RVector
*@see StatData
*@see QRDiagonalizer
*@see QR
*/

public class PrinComp {
    static void analyze(double[][] x, double[][] q, double[] lambda,
            int method) {
        int m = x.length, n = x[0].length;  // n s m (x[m][n])
        int ndf = n - ((method != 0) ? 1 : 0);   /* Rx */
        System.out.println("ϐ    ϒl     " +
            ((method == 0) ? "RMS" : "W΍"));
        NumberFormatter fmt12 = new NumberFormatter("12.6f"),
                        fmt8  = new NumberFormatter("8.6f"),
                        fmt6  = new NumberFormatter("6.1f"),
                        fmt3d = new NumberFormatter("3d");

        for (int j = 0; j < m; j++) {
            double t = 0;
            for (int i = 0; i < n; i++) t += x[j][i];
            t /= n;
            if (method != 0) for (int i = 0; i < n; i++) x[j][i] -= t;
            q[j][j] = RVector.innerProduct(x[j], x[j]) / ndf;
            double s = Math.sqrt(q[j][j]);
            System.out.println(fmt3d.toString(j + 1) +
                fmt12.toString(t) + fmt12.toString(s));
            if (method == 2) {
                q[j][j] = 1;
                for (int i = 0; i < n; i++) x[j][i] /= s;
            }
        }
        for (int j = 0; j < m; j++) for (int k = 0; k < j; k++)
            q[j][k] = q[k][j] = RVector.innerProduct(x[j], x[k]) / ndf;
        if (QR.eigen(q, lambda) != 0)
                        throw new Error("܂");
        double t = 0;  /* (trace) */
        for (int k = 0; k < m; k++) t += lambda[k];
        System.out.println("q    ŗLl       ݐρ");
        double s = 0;
        for (int k = 0; k < m; k++) {
            double percent = 100 * lambda[k] / t;  s += percent;
            System.out.println(fmt3d.toString(k + 1) +
                fmt12.toString(lambda[k]) + fmt6.toString(percent) +
                fmt6.toString(s));
        }

        System.out.println("v   " + fmt8.toString(t) +
            fmt6.toString(s));
        System.out.println("\nϐ  d");
        for (int j = 0; j < m; j++) {
            System.out.print(fmt3d.toString(j + 1));
            for (int k = 0; k < m && k < 5; k++)
                System.out.print(fmt12.toString(q[k][j]));
            System.out.println();
        }
        System.out.println("  听");
        for (int i = 0; i < n; i++) {
            System.out.print(fmt3d.toString(i + 1));
            for (int k = 0; k < m && k < 5; k++) {
                s = 0;
                for (int j = 0; j < m; j++) s += q[k][j] * x[j][i];
                System.out.print(fmt12.toString(s));
            }
            System.out.println();
        }
    }
    /**
    *t@Cf[^ǂݍŎ听͂s܂B<br>
    *<strong>gp@:<code> java PrinComp filename</strong></code><br>
    *ڂ͖{QƂĂB
    */
    public static void main(String[] args) throws IOException {
        if (args.length != 1) { /* bZ[W\I */
            System.err.println("gp@: java PrinComp filename");
            System.exit(-1);
        }

        System.out.print("0:̂܂ 1:ς 2:ɕW΍Ŋ ?");
        BufferedReader input = new
            BufferedReader(new InputStreamReader(System.in));
        int method = Integer.parseInt(input.readLine());

        if (method < 0 || method > 2) throw new Error("");
        StatData dataFile = new StatData(args[0]);
        int n = dataFile.numberOfRows(), m = dataFile.numberOfColumns();  // n s m 

        double[][] x = new double [m][n], q = new double[m][m];
        double[] lambda = new double[m];

        x = dataFile.readData();    /* f[^ǂ */
        analyze(x, q, lambda, method);  /* 听 */
    }
}
