/*
* QR.java -- QR@
* $Revision: 1.4 $, $Date: 2003/04/28 23:23:18 $
* class Tridiagonalize, RMatrix, RVector gB
*/
import java.io.*;
/**
*QR@gĎΏ̍s̑ΊpsvOłB
*@see Jacobi
*@see Tridiagonalize
*@see Householder
*@see RVector
*@see RMatrix
*/
public class QR {
    static final double EPS      = 1E-6;  // Ίp̋e덷
    static final int    MAX_ITER = 100;   // ő̌JԂ
    /**
    *a[0..n-1][0..n-1]ɓΏ̍s A ̑Ίps܂B<br>
    *d[k]ɌŗLlCa[k][i]ɂ͑k+1ŗLxNg̑i+1܂B
    *@return Ƃ0CȂƂ-1
    */
    public static int eigen(double[][] a, double[] d) {
        int n = d.length;
        double e[] = new double[n];  // Ɨp

        Tridiagonalize.getMatrix(a, d, e);  // 3dΊp
        System.arraycopy(e, 0, e, 1, e.length - 1); // 1ɃRs[
        e[0] = 0;  // Ԑl
        for (int h = n - 1; h > 0; h--) { // s̃TCYĂ
            int j = h;
            while (j > 0 && Math.abs(e[j]) > EPS * (Math.abs(d[j - 1]) + Math.abs(d[j])))
                j--;  // $\mbox{\tt e[$j$]} \ne 0$ ̃ubN̎n_
            if (j == h) continue;
            int iter = 0;
            do {
                if (++iter > MAX_ITER) return -1;
                double w = (d[h - 1] - d[h]) / 2, t = e[h] * e[h],
                       s = Math.sqrt(w * w + t);
                if (w < 0) s = -s;
                double x = d[j] - d[h] + t / (w + s), y = e[j + 1];
                for (int k = j; k < h; k++) {
                    double c;
                    if (Math.abs(x) >= Math.abs(y)) {
                        t = -y / x;  c = 1 / Math.sqrt(t * t + 1);
                        s = t * c;
                    } else {
                        t = -x / y;  s = 1 / Math.sqrt(t * t + 1);
                        c = t * s;
                    }
                    w = d[k] - d[k + 1];
                    t = (w * s + 2 * c * e[k + 1]) * s;
                    d[k] -= t;  d[k + 1] += t;
                    if (k > j) e[k] = c * e[k] - s * y;
                    e[k + 1] += s * (c * w - 2 * s * e[k + 1]);
                    // 5s͌ŗLxNg߂ȂȂsv
                    for (int i = 0; i < n; i++) {
                        x = a[k][i];  y = a[k + 1][i];
                        a[k    ][i] = c * x - s * y;
                        a[k + 1][i] = s * x + c * y;
                    }
                    if (k < h - 1) {
                        x = e[k + 1];  y = -s * e[k + 2];
                        e[k + 2] *= c;
                    }
                }
            } while (Math.abs(e[h]) >
                EPS * (Math.abs(d[h - 1]) + Math.abs(d[h])));
        }
    /*
    ȉ͌ŗLl̍~ɐ񂵂Ă邾BKvȂΏȂB
    ŗLxNg߂ȂȂŗLxNg̐͂svB
    */
        for (int k = 0; k < n - 1; k++) {
            int h = k;
            double t = d[h];

            for (int i = k + 1; i < n; i++)
                if (d[i] > t) {  h = i;  t = d[h];  }
            d[h] = d[k];  d[k] = t;
            // s a[][] ̑ h + 1 sƑ k + 1 šxNg v[] čsĂB
            double v[] = a[h];  a[h] = a[k];  a[k] = v;
        }
        return 0;
    }

    /**
    * gvOłB<br>
    *<b>"n = "</b>ƕĂ܂ 2 ȏ̐l()͂ĂB<br>
    *̍s ACŗLlC敽ό덷CŗLxNg̒𐫂o͂܂B
    */
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("n = ");
        int n = Integer.parseInt(in.readLine());
        double a[][] = new double[n][n], u[][] = new double[n][n],
               d[]   = new double[n];

        for (int i = 0; i < n; i++)
            for (int j = i; j < n; j++)
                u[i][j] = a[i][j] = a[j][i] = Math.random() - Math.random();

        System.out.println("A:");   RMatrix.print(a, 7, "10.6f");
        if (eigen(u, d) < 0) System.out.println("܂.");
        System.out.println("ŗLl:");  RVector.print(d, 5, "14.6f");

        double s = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                double t = 0;
                for (int k = 0; k < n; k++)
                    t += u[k][i] * d[k] * u[k][j];
                s += (a[i][j] - t) * (a[i][j] - t);
            }
        }
        System.out.println("敽ό덷: " + Math.sqrt(s) / n);

        NumberFormatter fmt = new NumberFormatter("14.5e");
        System.out.println("\nŗLxNg̒𐫂̊mF");
        for (int i = 0; i < n; i++)
            for (int j = i + 1; j < n; j++)
                System.out.println("u[" + i + "]Eu[" + j + "] = "
                    + fmt.toString(RVector.innerProduct(u[i], u[j])));
    }
}
