/**
 *  xNgNXF
 *
 *  xNg(double ̔z)ɑ΂e퉉Z\bh񋟂܂B
 *
 *  @version $Revision: 1.6 $, $Date: 2003/03/13 14:24:35 $
 */
public class RVector {
    /**
     *  l (lhs + rhs) ƂȂxNgԂ܂B
     *  @param  lhs 
     *  @param  rhs E
     *  @return (lhs + rhs)
     */
    public static double[] add(double[] lhs, double[] rhs) {
        if (lhs.length != rhs.length)
            throw new IndexOutOfBoundsException();
        double[] ret = new double[lhs.length];
        for (int i = 0; i < lhs.length; i++) ret[i] = lhs[i] + rhs[i];
        return ret;
    }
    /**
     *  l (lhs - rhs) ƂȂxNgԂ܂B
     *  @param  lhs 
     *  @param  rhs E
     *  @return (lhs - rhs)
     */
    public static double[] subtract(double[] lhs, double[] rhs) {
        if (lhs.length != rhs.length)
            throw new IndexOutOfBoundsException();
        double[] ret = new double[lhs.length];
        for (int i = 0; i < lhs.length; i++) ret[i] = lhs[i] - rhs[i];
        return ret;
    }
    /**
     *  l (a * v) ƂȂxNgԂ܂B
     *  @param  a   XJ[
     *  @param  v   xNg
     *  @return (a * v)
     */
    public static double[] multiply(double a, double[] v) {
        double[] ret = new double[v.length];
        for (int i = 0; i < v.length; i++) ret[i] = a * v[i];
        return ret;
    }
    /**
     *  xNg ns Ԗڂ̗vf ne - 1 Ԗڂ̗vf܂ł
     *  ςԂ܂B
     *  @param  ns  aŏ̗vfԍ
     *  @param  ne  aŌ̗vf̗̎vfԍ
     *  @param  lhs 
     *  @param  rhs E
     *  @return ς̒l
     */
    public static double innerProduct(int ns, int ne,
                                      double[] lhs, double[] rhs) {
        if (ns < 0 || ne < 0 || ns > ne) throw new IndexOutOfBoundsException("error in RVector\n");
        double  s = 0.0;
        int n5 = (ne - ns) % 5;
        for (int i = ns; i < ns + n5; i++) s += lhs[i] * rhs[i];
        for (int i = ns + n5; i < ne; i += 5)
            s += lhs[i] * rhs[i] + lhs[i+1] * rhs[i+1]
               + lhs[i+2] * rhs[i+2] + lhs[i+3] * rhs[i+3]
               + lhs[i+4] * rhs[i+4];
        return s;
    }
    /**
     *  xNg ns Ԗڂ̗vfŌ̗vf܂ł̓ςԂ܂B
     *  @param  ns  aŏ̗vfԍ
     *  @param  lhs 
     *  @param  rhs E
     *  @return ς̒l
     */
    public static double innerProduct(int ns, double[] lhs, double[] rhs) {
        return innerProduct(ns, lhs.length, lhs, rhs);
    }
    /**
     *  xNg̓ςԂ܂B
     *  @param  lhs 
     *  @param  rhs E
     *  @return ς̒l
     */
    public static double innerProduct(double[] lhs, double[] rhs) {
        return innerProduct(0, lhs.length, lhs, rhs);
    }
/***************** ȉ͈\bh ***************************************/
    /**
     *  xNg ns Ԗڂ̗vf ne - 1 Ԗڂ̗vf
     *  ܂B
     *  @see NumberFormatter
     *  @param  ns  n߂ŏ̗vfԍ
     *  @param  ne  Ō̗vf̗̎vfԍ
     *  @param  perline 1sɈvf
     *  @param  format  NumberFormatter ɗ^
     */
    public static void print(int ns, int ne, double[] v,
                                    int perLine, String format) {
        if (ns < 0 || ne < 0 || ns > ne) throw new IndexOutOfBoundsException();
        NumberFormatter fmt = new NumberFormatter(format);
        int k = 0;

        for (int j = ns; j < ne; j++) {
            System.out.print(fmt.toString(v[j]));
            if (++k >= perLine) {  k = 0;  System.out.println();  }
        }
        if (k != 0) System.out.println();
    }

    /**
     *  xNg ns Ԗڂ̗vfŌ̗vf܂ł܂B
     *  @see NumberFormatter
     *  @param  ns      n߂ŏ̗vfԍ
     *  @param  perLine 1sɈvf
     *  @param  format  NumberFormatter ɗ^
     */
    public static void print(int ns, double[] v, int perLine, String format) {
        print(ns, v.length, v, perLine, format);
    }
    /**
     *  xNg̑Svf܂B
     *  @see NumberFormatter
     *  @param  perLine 1sɈvf
     *  @param  format  NumberFormatter ɗ^
     */
    public static void print(double[] v, int perLine, String format) {
        print(0, v.length, v, perLine, format);
    }
}

