/**
 *  RegulaFalsi.java -- ݂͂@
 *
 *  @version $Revision: 1.7 $, $Date: 2003/04/05 15:10:00 $
 */

public class RegulaFalsi {
    /** _߂֐ f(x) */
    public interface Function {  public double of(double x);  }

    /** @BGvV */
    static final double DBL_EPSILON = 2.2204460492503131E-16;

    /** Ȃ^ */
    private static boolean isSameSign(double a, double b) {
        return (a > 0) == (b > 0);
    }

    /** f(x) = 0 ̉ [a,b] 狖e덷 tolerance ŋ߂B
        ŏ iMax ݂͂͂@Cȍ~2@gB */
    public static double solve(Function f, double a, double b,
                               double tolerance, int iMax) {
        if (tolerance < 0) tolerance = 0;
        if (b < a) {  double swap = a;  a = b;  b = swap;  }
        double fa = f.of(a);  if (fa == 0) return a;
        double fb = f.of(b);  if (fb == 0) return b;
        if (isSameSign(fa, fb))
            throw new Error("Ԃ̗[Ŋ֐lłB");
        for (int i = 0; ; i++) {
            double c = (a + b) / 2;
            if (c - a <= tolerance || b - c <= tolerance) return c;
            if (i < iMax) {
                c = (a * fb - b * fa) / (fb - fa);
                if      (c <= a) c = a + 0.6 * DBL_EPSILON * Math.abs(a);
                else if (c >= b) c = b - 0.6 * DBL_EPSILON * Math.abs(b);
            }
            double fc = f.of(c);  if (fc == 0) return c;
            if (isSameSign(fc, fa)) {  a = c;  fa = fc;  }
            else                    {  b = c;  fb = fc;  }
        }
    }

    /** f(x) = x^2 - 2 ׂ */
    public static void main(String[] args) {
        class Function implements RegulaFalsi.Function {
            int count = 0;  // f(x)̌Ăяo񐔃JE^
            public double of(double x) {
                double value = x * x - 2;
                System.out.println((++count)
                                   + ":  x = " + x
                                   + "  f(x) = " + value);
                return value;
            }
        }

        System.out.println("2@");
        double x = RegulaFalsi.solve(new Function(), 1, 2, 1e-6, 0);
        System.out.println(" x = " + x);
        System.out.println("sqrt(2.0) - x = " + (Math.sqrt(2) - x));

        System.out.println("regula falsi@");
        x = RegulaFalsi.solve(new Function(), 1, 2, 1e-6, 1000);
        System.out.println(" x = " + x);
        System.out.println("sqrt(2.0) - x = " + (Math.sqrt(2) - x));
    }
}
