/**
 *  Simplex.java -- `v@
 *
 *  @version $Revision: 2.13 $, $Date: 2003/03/21 20:37:38 $
 */

import java.io.*;
import java.util.*;
import java.text.*;

public class Simplex {
    static final double EPSILON = 1E-6;  // 
    /** ASY̓rŕωȂϐ */
    static double[][] a;  // ̌W
    static char[] inequality;  //  <, >, =
    static double[] c;    // ړI֐̌W
    static int m, n;      // sij, iϐj̐
    static int n1;        // n + ̃XbNϐ̐
    static int n2;        // n1 + ̃XbNϐ̐
    static int n3;        // n2 + lוϐ̐
    static int[] nonZeroRow;   // XbNElוϐ0łȂs
    /** ASY̓rŕωϐ */
    static double[][] q;  // ϊs
    static int jmax;      // ŉE̔ԍ
    static int[] col;     // es̊ϐ̔ԍ
    static int[] row;     // ̗񂪊ȂΉ̔ԍ, łȂ0

    /** G[\, I */
    private static void exitError(String message) {
        System.err.println("\n" + message);  System.exit(1);
    }

    /** I */
    private static void exitNormal(String message) {
        System.out.println(message);  System.exit(0);
    }

    /** ɕϊ */
    private static double nextDouble(StringTokenizer t) {
        return Double.valueOf(t.nextToken()).doubleValue();
    }

    /** W͂f[^ǂ */
    private static void readData() throws IOException {
        BufferedReader in =
            new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer t = new StringTokenizer(in.readLine());
        m = Integer.parseInt(t.nextToken());
        n = Integer.parseInt(t.nextToken());
        if (m < 1) exitError("̐ m  1 ł");
        if (n < 1) exitError("ϐ̐ n  1 ł");
        System.out.println(m + "  " + n + " ϐ");

        a = new double[m + 1][n + 1];
        c = new double[n + 1];
        q = new double[m + 1][m + 1];
        col         = new int[m + 1];
        row         = new int[n + 2 * m + 1];
        nonZeroRow  = new int[n + 2 * m + 1];
        inequality  = new char[m + 1];

        t = new StringTokenizer(in.readLine());
        for (int j = 1; j <= n; j++) c[j] = nextDouble(t);
        c[0] = -nextDouble(t);  // c[0] ̕tɂ

        for (int i = 1; i <= m; i++) {
            t = new StringTokenizer(in.readLine());
            for (int j = 1; j <= n; j++) a[i][j] = nextDouble(t);
            inequality[i] = t.nextToken().charAt(0);
            if ("<>=".indexOf(inequality[i]) == -1)
                exitError("̓G[");
            a[i][0] = nextDouble(t);
            if (a[i][0] < 0) {
                if      (inequality[i] == '>') inequality[i] = '<';
                else if (inequality[i] == '<') inequality[i] = '>';
                for (int j = 0; j <= n; j++) a[i][j] = -a[i][j];
            } else if (a[i][0] == 0 && inequality[i] == '>') {
                inequality[i] = '<';
                for (int j = 1; j <= n; j++) a[i][j] = -a[i][j];
            }
        }
    }

    /**  */
    private static void prepare() {
        n1 = n;
        for (int i = 1; i <= m; i++)
            if (inequality[i] == '>') {  // W -1 ̃XbNϐ
                n1++;  nonZeroRow[n1] = i;
            }
        n2 = n1;
        for (int i = 1; i <= m; i++)
            if (inequality[i] == '<') {  // W +1 ̃XbNϐ
                n2++;  col[i] = n2;
                nonZeroRow[n2] = row[n2] = i;
            }
        n3 = n2;
        for (int i = 1; i <= m; i++)
            if (inequality[i] != '<') {  // lוϐ
                n3++;  col[i] = n3;
                nonZeroRow[n3] = row[n3] = i;
            }
        for (int i = 0; i <= m; i++) q[i][i] = 1;
    }

    /** VvbNX\ (i,j) vZ */
    private static double tableau(int i, int j) {
        if (col[i] < 0) return 0;  // 璷ȏ̂ߏs
        if (j <= n) {
            double sum = 0;
            for (int k = 0; k <= m; k++) sum += q[i][k] * a[k][j];
            return sum;
        }
        double u = q[i][nonZeroRow[j]];
        if (j <= n1) return -u;
        if (j <= n2 || i != 0) return u;
        return u + 1;  // j > n2 && i == 0
    }

    /** fXg[V̂߃VvbNX\o */
    private static void printTableau() {  printTableau(-1, -1);  }
    private static void printTableau(int ipivot, int jpivot) {
        System.out.print("              ");
        for (int j = 1; j <= jmax; j++) {
            String s = (row[j]==0 ? "   " : "  @") + "x[" + j + "] ";
            System.out.print(s.substring(0, 8) +
                ((j == 0 || j == n || j == n2) ? "|" : ""));
        }
        System.out.println();
        final DecimalFormat df = new DecimalFormat("####0.00");
        for (int i = 0; i <= m; i++) {
            if (col[i] < 0) continue;  // 璷ȏ
            String s = "  " + i + ": ";
            System.out.print(s.substring(s.length() - 5));
            for (int j = 0; j <= jmax; j++) {
                s = "    " + df.format(tableau(i, j));
                System.out.print(s.substring(s.length() - 7) +
                    ((i == ipivot && j == jpivot) ? '*' : ' ') +
                    ((j == 0 || j == n || j == n2) ? "|" : ""));
            }
            System.out.println();
        }
    }

    /** |o */
    private static void pivot(int ipivot, int jpivot,
                                          double[] pivotColumn) {
        System.out.println("s{bg(" + ipivot + "," + jpivot + ")");
        for (int j = 1; j <= m; j++)
            q[ipivot][j] /= pivotColumn[ipivot];
        for (int i = 0; i <= m; i++)
            if (i != ipivot) {
                final double u = pivotColumn[i];
                for (int j = 1; j <= m; j++)
                    q[i][j] -= q[ipivot][j] * u;
            }
        row[col[ipivot]] = 0;
        col[ipivot] = jpivot;  row[jpivot] = ipivot;
    }

    /** ŏ */
    private static void minimize() {
        double[] pivotColumn = new double[m + 1];
        for ( ; ; ) {
            int jpivot;  // s{bg jpivot 
            for (jpivot = 1; jpivot <= jmax; jpivot++)
                if (row[jpivot] == 0) {  // łȂ
                    pivotColumn[0] = tableau(0, jpivot);
                    if (pivotColumn[0] < -EPSILON) break;
                }
            if (jpivot > jmax) break;  // ŏ
            int ipivot = 0;  // s{bgs ipivot 
            double uMin = Double.MAX_VALUE;
            for (int i = 1; i <= m; i++) {
                pivotColumn[i] = tableau(i, jpivot);
                if (pivotColumn[i] > EPSILON) {
                    double u = tableau(i, 0) / pivotColumn[i];
                    if (u < uMin) {  ipivot = i;  uMin = u;  }
                }
            }
            if (ipivot == 0) exitNormal("ړI֐͉܂");
            printTableau(ipivot, jpivot);
            pivot(ipivot, jpivot, pivotColumn);
        }
        printTableau();
        System.out.println("ŏl " + (-tableau(0, 0)) + " ł");
    }

    /** tF[YP */
    private static void phase1() {
        System.out.println("tF[YP");
        jmax = n3;
        for (int j = n2 + 1; j <= n3; j++) q[0][row[j]] = -1;
        minimize();
        if (tableau(0, 0) < -EPSILON) exitNormal("\ȉ͂܂");
        for (int i = 1; i <= m; i++)  // lוϐȂ
            if (col[i] > n2) {
                int j;
                for (j = 1; j <= n; j++)
                    if (row[j] == 0
                        && Math.abs(tableau(i, j)) > EPSILON) {
                        // System.out.println("܂ȏł̏");
                        double[] pivotColumn = new double[m + 1];
                        for (int k = 0; k <= m; k++)
                            pivotColumn[k] = tableau(k, j);
                        pivot(i, j, pivotColumn);
                        break;
                    }
                if (j > n) {
                    System.out.println(" " + i + " ͏璷ł");
                    col[i] = -1;
                }
            }
        q[0][0] = 1;  //  tF[YQ֌C
        for (int i = 1; i <= m; i++) q[0][i] = 0;
        for (int j = 1; j <= n; j++)
            if (row[j] != 0 && c[j] != 0)
                for (int i = 1; i <= m; i++)
                    q[0][i] -= q[row[j]][i] * c[j];
    }

    /** tF[YQ */
    private static void phase2() {
        System.out.println("tF[YQ");
        jmax = n2;
        for (int j = 0; j <= n; j++) a[0][j] = c[j];  // ړI֐
        minimize();
    }

    /** ʂ̏o */
    private static void printVariable() {
        System.out.println("0 łȂϐ̒l:");
        for (int j = 1; j <= n; j++) {
            final int i = row[j];
            if (i != 0)
                System.out.println("x[" + j + "] = " + tableau(i, 0));
        }
    }

    public static void main(String[] args) throws IOException {
        readData();                 // f[^ǂ
        prepare();                  // 炦
        if (n3 != n2) phase1();     // tF[Y1
        phase2();                   // tF[Y2
        printVariable();            // ʂ̏o
    }
}
