// $Revision: 1.6 $, $Date: 2003/04/28 23:23:19 $

public class Spline2 {
    private double[] p;
    private Spline sx, sy;

    public Spline2(double[] x, double[] y) { // RXgN^
        int n = x.length;
        p = new double[n];
        p[0] = 0;
        for (int i = 1; i < n; i++) {
            double t1 = x[i] - x[i - 1], t2 = y[i] - y[i - 1];
            p[i] = p[i - 1] + Math.sqrt(t1 * t1 + t2 * t2);
        }
        for (int i = 1; i < n; i++) p[i] /= p[n - 1];
        sx = new Spline(p, x);
        sy = new Spline(p, y);
    }

    public double[] interpolate(double t) { // z {x(t), y(t)} Ԃ
        return new double[] { sx.interpolate(t), sy.interpolate(t) };
    }

    // eXgp
    public static void main(String[] args) {
        double[] x = new double[] {1,2,3,4,5},
                 y = new double[] {2,1,2,3,5};
        Spline2 spl2 = new Spline2(x, y);
        for (int i = 0; i <= 10; i++) {
            double[] point = spl2.interpolate(i / 10.0);
            System.out.println("t = " + (i / 10.0)
                               + ", x = " + point[0]
                               + ", y = " + point[1]);
        }
    }
}
